unit IAChartBaseAxisEditUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,Math;

type
  TIAChartBaseAisEditWindow = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    Button3: TButton;
    Button4: TButton;
    FontDialog1: TFontDialog;
    ColorDialog1: TColorDialog;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button5: TButton;
    Bevel1: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit5KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit5Exit(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
    function StrToFloatTIADef(S : string;AValue : Extended): Extended;
    function FloatToStrTIAFixedDef(AValue : EXtended;AMaxSign,AMinAccuracy : Byte): string;
  public
    FCurrControl : TControl;
    procedure BackUpdate;
    { Public declarations }
  end;

var
  IAChartBaseAisEditWindow: TIAChartBaseAisEditWindow;

implementation
Uses IAChartBaseAxisUnit,IAUniChart2D;
var CurrAxis : IAChartBaseAxisClass;

{$R *.DFM}

procedure TIAChartBaseAisEditWindow.FormCreate(Sender: TObject);
begin
  CurrAxis:=IAChartBaseAxisClass.Create(self);
  CurrAxis.parent:=panel1;
  CurrAxis.Autoeditable:=false;
  CurrAxis.centerpointTop:=Panel1.clientheight div 2;
  CurrAxis.width:=panel1.clientWidth;
end;

procedure TIAChartBaseAisEditWindow.FormDestroy(Sender: TObject);
begin
  CurrAxis.parent:=nil;
  CurrAxis.free;
end;

procedure TIAChartBaseAisEditWindow.FormActivate(Sender: TObject);
begin
  if assigned(FCurrControl) and (FCurrControl is IAChartBaseAxisClass) then
    begin
      CurrAxis.BeginShift:=(FCurrControl as IAChartBaseAxisClass).BeginShift;
      CurrAxis.EndShift:=(FCurrControl as IAChartBaseAxisClass).EndShift;
      CurrAxis.ScaleStyle:=(FCurrControl as IAChartBaseAxisClass).ScaleStyle;
      CurrAxis.MinorTicks:=(FCurrControl as IAChartBaseAxisClass).MinorTicks;
      CurrAxis.WantedTicks:=(FCurrControl as IAChartBaseAxisClass).WantedTicks;
      CurrAxis.EndValue:=(FCurrControl as IAChartBaseAxisClass).EndValue;
      CurrAxis.BeginValue:=(FCurrControl as IAChartBaseAxisClass).BeginValue;
      CurrAxis.CurrImageList:=(FCurrControl as IAChartBaseAxisClass).CurrImageList;
      CurrAxis.Font:=(FCurrControl as IAChartBaseAxisClass).Font;
      CurrAxis.Color:=(FCurrControl as IAChartBaseAxisClass).Color;


      Panel1.Color:=((FCurrControl as IAChartBaseAxisClass).parent.parent as TIAUniChart2D).color;
      Edit5.text:=FloatToStrTIAFixedDef(CurrAxis.BeginValue,4,5);
      Edit6.text:=FloatToStrTIAFixedDef(CurrAxis.EndValue,4,5);

      EDit1.text:=inttostr(CurrAxis.BeginShift);
      EDit2.text:=inttostr(CurrAxis.EndShift);
      EDit3.text:=inttostr(CurrAxis.WantedTicks);
      EDit4.text:=inttostr(CurrAxis.MinorTicks);
    end;
end;

procedure TIAChartBaseAisEditWindow.BackUpdate;
begin
    if assigned(FCurrControl) and (FCurrControl is IAChartBaseAxisClass) then
    begin
      (FCurrControl as IAChartBaseAxisClass).BeginShift:=CurrAxis.BeginShift;
      (FCurrControl as IAChartBaseAxisClass).EndShift:=CurrAxis.EndShift;
      (FCurrControl as IAChartBaseAxisClass).ScaleStyle:=CurrAxis.ScaleStyle;
      (FCurrControl as IAChartBaseAxisClass).MinorTicks:=CurrAxis.MinorTicks;
      (FCurrControl as IAChartBaseAxisClass).WantedTicks:=CurrAxis.WantedTicks;
      (FCurrControl as IAChartBaseAxisClass).EndValue:=CurrAxis.EndValue;
      (FCurrControl as IAChartBaseAxisClass).BeginValue:=CurrAxis.BeginValue;
      (FCurrControl as IAChartBaseAxisClass).CurrImageList:=CurrAxis.CurrImageList;
      (FCurrControl as IAChartBaseAxisClass).Font:=CurrAxis.Font;
      (FCurrControl as IAChartBaseAxisClass).Color:=CurrAxis.Color;
    end;
end;

procedure TIAChartBaseAisEditWindow.Edit1Change(Sender: TObject);
begin
  (sender as TEdit).text:=inttostr(strtointdef((sender as TEdit).text,0));
  if (sender as TEdit)=Edit1 then
    begin
      CurrAxis.BeginShift:=strtointdef((sender as TEdit).text,0);
    end else
    begin
      if (sender as TEdit)=Edit2 then
        begin
          CurrAxis.EndShift:=strtointdef((sender as TEdit).text,0);
        end else
        begin
          if (sender as TEdit)=Edit3 then
            begin
              CurrAxis.WantedTicks:=strtointdef((sender as TEdit).text,0);
            end else
            begin
              if (sender as TEdit)=Edit4 then
                begin
                  CurrAxis.MinorTicks:=strtointdef((sender as TEdit).text,0);
                end else
                begin

                end;
            end;
        end;
    end;
end;

function TIAChartBaseAisEditWindow.FloatToStrTIAFixedDef(AValue: EXtended;
  AMaxSign, AMinAccuracy: Byte): string;
var APower : integer;
    s1,s2 : string;
begin
  s1:='%'+inttostr(AMaxSign+AMinAccuracy)+'.'+inttostr(AMinAccuracy)+'f';
  s2:='%'+inttostr(AMaxSign+AMinAccuracy+3)+'.'+inttostr(AMinAccuracy+3)+'e';
  if AValue<>0 then
    begin
      if AValue>=1 then APower:=trunc(log10(abs(AValue))) else APower:=trunc(log10(abs(AValue)))-1;
      if APower<AMaxSign then
        begin
          result:=format(s1,[AValue]);
        end else
        begin
          result:=format(s2,[AValue]);
        end;
    end else
    begin
      result:=format(s1,[AValue]);
    end;
end;

function TIAChartBaseAisEditWindow.StrToFloatTIADef(S: string;
  AValue: Extended): Extended;
var N : integer;
begin
  N:=pos(DecimalSeparator,s);
  if N>0 then
    begin
      try
        result:=strtofloat(s);
      except
        result:=AValue;
      end;
    end else
    begin
      try
        result:=strtoint(s);
      except
        result:=AValue;
      end;
    end;
end;

procedure TIAChartBaseAisEditWindow.Edit5KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key=13 then
    begin
      (sender as TEdit).text:=FloatToStrTIAFixedDef(StrToFloatTIADef((sender as TEdit).text,0.0),4,5);
      if (sender as TEdit)=Edit5 then
        begin
          CurrAxis.BeginValue:=StrToFloatTIADef((sender as TEdit).text,0.0);
        end else
        begin
          if (sender as TEdit)=Edit6 then
            begin
              CurrAxis.EndValue:=StrToFloatTIADef((sender as TEdit).text,0.0);
            end else
            begin

            end;
        end;
    end;
end;

procedure TIAChartBaseAisEditWindow.Edit5Exit(Sender: TObject);
begin
  (sender as TEdit).text:=FloatToStrTIAFixedDef(StrToFloatTIADef((sender as TEdit).text,0.0),4,5);
  if (sender as TEdit)=Edit5 then
    begin
      CurrAxis.BeginValue:=StrToFloatTIADef((sender as TEdit).text,0.0);
    end else
    begin
      if (sender as TEdit)=Edit6 then
        begin
          CurrAxis.EndValue:=StrToFloatTIADef((sender as TEdit).text,0.0);
        end else
        begin

        end;
    end;
end;

procedure TIAChartBaseAisEditWindow.Button3Click(Sender: TObject);
begin
FontDialog1.font:=CurrAxis.font;
  if FontDialog1.Execute then
    begin
      CurrAxis.font:=FontDialog1.font;
    end;
end;

procedure TIAChartBaseAisEditWindow.Button4Click(Sender: TObject);
begin
ColorDialog1.color:=CurrAxis.font.color;
if ColorDialog1.execute then
  begin
    CurrAxis.font.color:=ColorDialog1.color;
  end;
end;

procedure TIAChartBaseAisEditWindow.Button5Click(Sender: TObject);
begin
ColorDialog1.color:=CurrAxis.color;
if ColorDialog1.execute then
  begin
    CurrAxis.color:=ColorDialog1.color;
  end;
end;

end.
