unit IAChartBaseLinesUnit;

interface
 uses Windows, Messages,Controls,SysUtils, Classes,Graphics,IAChartBaseMovingUnit,IAChartBaseAxisUnit,
 Math,IAChartBaseLinesEditUnit;

const
  CM_BASELINESMOVED = CM_BASE+150;
  CM_BASELINESSIZED = CM_BASE+151;
  CM_USERWANTSRESIZE = CM_BASE+152;
  CM_USERCHANGELINESREPRESENTATION = CM_BASE+153;

type
IAChartDataArray = array of Double;
IAChartBaseLineType =(iacbltXData,iacbltYData,iacbltY2Data,iacbltOffsetData);
IAChartBaseLinePointType = (iacblptNone,iacblptCircle,iacblptSquare,iacblptTriangle);
IAChartBaseLineStyle = (iacblsNone,iacblsLine,iacblsSpline);
IAChartBaseLineDiapasonType  = (iacbldtNone,iacbldtCross,iacbldtRect);

IAChartBaseLine = class(TPersistent)
private
  FOwner : TComponent;
    FData: IAChartDataArray;
    FNumber: Integer;
    FPointSize: Byte;
    FXLine: Integer;
    FYsubLine: Integer;
    FYaddLine: Integer;
    FXaddLine: Integer;
    FXsubLine: Integer;
    FPointType: IAChartBaseLinePointType;
    FLineType: IAChartBaseLineType;
    FPointColor: TColor;
    FLineStyle: IAChartBaseLineStyle;
    FLineColor: TColor;
    FDiapasonType: IAChartBaseLineDiapasonType;
    FDiapasonColor: TColor;
    FInfoString: string;
    procedure SetData(Value: IAChartDataArray);
    procedure SetNumber(Value: Integer);
    procedure SetLineType(Value: IAChartBaseLineType);
    procedure SetPointColor(Value: TColor);
    procedure SetPointSize(Value: Byte);
    procedure SetPointType(Value: IAChartBaseLinePointType);
    procedure SetXaddLine(Value: Integer);
    procedure SetXLine(Value: Integer);
    procedure SetXsubLine(Value: Integer);
    procedure SetYaddLine(Value: Integer);
    procedure SetYsubLine(Value: Integer);
    procedure SetLineColor(Value: TColor);
    procedure SetLineStyle(Value: IAChartBaseLineStyle);
    procedure SetDiapasonColor(Value: TColor);
    procedure SetDiapasonType(Value: IAChartBaseLineDiapasonType);
    procedure SetInfoString(Value: string);


protected

public
  procedure Assign(Source: TPersistent); override;
  constructor Create(AOwner: TComponent); virtual;
  destructor Destroy; override;

  property Data : IAChartDataArray read FData write SetData;
  property Number : Integer read FNumber write SetNumber;
  property LineType : IAChartBaseLineType read FLineType write SetLineType;
  property XLine : Integer read FXLine write SetXLine;
  property XaddLine : Integer read FXaddLine write SetXaddLine;
  property XsubLine : Integer read FXsubLine write SetXsubLine;
  property YaddLine : Integer read FYaddLine write SetYaddLine;
  property YsubLine : Integer read FYsubLine write SetYsubLine;
  property PointType : IAChartBaseLinePointType read FPointType write SetPointType;
  property PointSize : Byte read FPointSize write SetPointSize;
  property PointColor : TColor read FPointColor write SetPointColor;
  property LineStyle : IAChartBaseLineStyle read FLineStyle write SetLineStyle;
  property LineColor : TColor read FLineColor write SetLineColor;
  property DiapasonType : IAChartBaseLineDiapasonType read FDiapasonType write SetDiapasonType;
  property DiapasonColor : TColor read FDiapasonColor write SetDiapasonColor;
  property InfoString : string read FInfoString write SetInfoString;
end;
IAChartDataArrayArr = array of IAChartBaseLine;
IAChartBaseLineArray = class(TPersistent)
private
  FOwner : TComponent;
    FLines: IAChartDataArrayArr;
    FDataNumber: Integer;
    FLinesNumber: Integer;
    FCommonInfo: string;
    procedure SetDataNumber(Value: Integer);
    procedure SetLines(Value: IAChartDataArrayArr);
    procedure SetLinesNumber(Value: Integer);

    procedure DrawSpline(ACanvas : TCanvas;x1,x2,x3,x4,y1,y2,y3,y4 : integer);
    procedure SetCommonInfo(Value: string);
protected

public
  procedure DrawOnCanvas(ACanvas : TCanvas);

  procedure Assign(Source: TPersistent); override;
  constructor Create(AOwner: TComponent); virtual;
  destructor Destroy; override;

  property Lines : IAChartDataArrayArr read FLines write SetLines;
  property LinesNumber : Integer read FLinesNumber write SetLinesNumber;
  property DataNumber : Integer read FDataNumber write SetDataNumber;
  property CommonInfo : string read FCommonInfo write SetCommonInfo;
end;
IAChartBaseLinesClass = class;
IAChartBaseLinesClassData = class(TPersistent)
  private
    FLinesField : IAChartBaseLinesClass;
    function GetColor: TColor;
    function GetHeight: integer;
    function GetLeft: Integer;
    function GetTop: integer;
    function GetTransparent: Boolean;
    function GetWidth: integer;
    procedure SetColor(Value: TColor);
    procedure SetHeight(Value: integer);
    procedure SetLeft(Value: Integer);
    procedure SetTop(Value: integer);
    procedure SetTransparent(Value: Boolean);
    procedure SetWidth(Value: integer);
    function GetMoveAble: Boolean;
    function GetSelectable: Boolean;
    function GetSizeAble: Boolean;
    procedure SetMoveAble(Value: Boolean);
    procedure SetSelectable(Value: Boolean);
    procedure SetSizeAble(Value: Boolean);
    function GetColorGridX: TColor;
    function GetColorGridY: TColor;
    function GetColorGridY2: TColor;
    function GetShowGrid: boolean;
    procedure SetColorGridX(Value: TColor);
    procedure SetColorGridY(Value: TColor);
    procedure SetColorGridY2(Value: TColor);
    procedure SetShowGrid(Value: boolean);
    function GetColorGridBorder: TColor;
    procedure SetColorGridBorder(Value: TColor);
    function GetMainDataArray: IAChartBaseLineArray;
    procedure SetMainDataArray(Value: IAChartBaseLineArray);
    function GetLastDoubleClickedPointDataNumber: Integer;
    function GetLastDoubleClickedPointLineNumber: Integer;
    function GetAutoEditable: Boolean;
    procedure SetAutoEditable(Value: Boolean);
    function GetAutoEditMinDistance: Integer;
    procedure SetAutoEditMinDistance(Value: Integer);

  protected

  public
    procedure Assign(Source: TPersistent); override;
    constructor Create(AOwner: TComponent); virtual;
    destructor Destroy; override;

    property MainDataArray : IAChartBaseLineArray read GetMainDataArray write SetMainDataArray;
    property LastDoubleClickedPointLineNumber : Integer read GetLastDoubleClickedPointLineNumber;
    property LastDoubleClickedPointDataNumber : Integer read GetLastDoubleClickedPointDataNumber;
  published
    property Width : integer read GetWidth write SetWidth;
    property Height : integer read GetHeight write SetHeight;
    property Top : integer read GetTop write SetTop;
    property Left : Integer read GetLeft write SetLeft;
    property Color: TColor read GetColor write SetColor;
    property Transparent : Boolean read GetTransparent write SetTransparent;
    property SizeAble : Boolean read GetSizeAble write SetSizeAble;
    property MoveAble : Boolean read GetMoveAble write SetMoveAble;
    property Selectable : Boolean read GetSelectable write SetSelectable;
    property ShowGrid : boolean read GetShowGrid write SetShowGrid;
    property ColorGridX : TColor read GetColorGridX write SetColorGridX;
    property ColorGridY : TColor read GetColorGridY write SetColorGridY;
    property ColorGridY2 : TColor read GetColorGridY2 write SetColorGridY2;
    property ColorGridBorder : TColor read GetColorGridBorder write SetColorGridBorder;
    property AutoEditable : Boolean read GetAutoEditable write SetAutoEditable;
    property AutoEditMinDistance : Integer read GetAutoEditMinDistance write SetAutoEditMinDistance;
  end;
  IAChartBaseLinesClass = class(IAChartBaseMovingClass)
    private
    FPaintedPoints : array of array of array [0..1] of integer;
    IsMouseDown : Boolean;
    MDownPos,MUpPos : TPoint;
    FYAxis2Begin: Double;
    FYAxisBegin: double;
    FYAxisEnd: Double;
    FXAxisBegin: double;
    FYAxis2End: Double;
    FYAxis2Style: IAChartBaseAxisStyle;
    FXAxisStyle: IAChartBaseAxisStyle;
    FYAxisStyle: IAChartBaseAxisStyle;
    FXAxisType: IAChartBaseAxisType;
    FXAxisEnd: Double;
    FShowGrid: boolean;
    FYAxisStep: double;
    FYAxis2Step: double;
    FXAxisStep: double;
    FColorGridX: TColor;
    FColorGridY2: TColor;
    FColorGridY: TColor;
    FColorGridBorder: TColor;
    FLastDoubleClickedPointLineNumber : Integer;
    FLastDoubleClickedPointDataNumber : Integer;
    FMainDataArray: IAChartBaseLineArray;
    FAutoEditable: Boolean;
    FAutoEditMinDistance: Integer;
    function GetColor: TColor;
    function GetHeight: integer;
    function GetLeft: Integer;
    function GetTop: integer;
    function GetTransparent: Boolean;
    function GetWidth: integer;
    procedure SetColor(Value: TColor);
    procedure SetHeight(Value: integer);
    procedure SetLeft(Value: Integer);
    procedure SetTop(Value: integer);
    procedure SetTransparent(Value: Boolean);
    procedure SetWidth(Value: integer);
    procedure SetXAxisBegin(Value: double);
    procedure SetXAxisStyle(Value: IAChartBaseAxisStyle);
    procedure SetXAxisType(Value: IAChartBaseAxisType);
    procedure SetYAxis2Begin(Value: Double);
    procedure SetYAxis2End(Value: Double);
    procedure SetYAxis2Style(Value: IAChartBaseAxisStyle);
    procedure SetYAxisBegin(Value: double);
    procedure SetYAxisEnd(Value: Double);
    procedure SetYAxisStyle(Value: IAChartBaseAxisStyle);
    procedure SetXAxisEnd(Value: Double);
    procedure SetColorGridX(Value: TColor);
    procedure SetColorGridY(Value: TColor);
    procedure SetColorGridY2(Value: TColor);
    procedure SetShowGrid(Value: boolean);
    procedure SetXAxisStep(Value: double);
    procedure SetYAxis2Step(Value: double);
    procedure SetYAxisStep(Value: double);
    procedure DrawGrid;
    procedure SetColorGridBorder(Value: TColor);
    function UnderlayInt(AValue: Double): integer;
    procedure SetMainDataArray(Value: IAChartBaseLineArray);
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
    procedure WMMouseMove(var Message: TWMMouseMove); message WM_MOUSEMOVE;
    procedure WMLButtonDblClk(var Message: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;
    function GetLastDoubleClickedPointDataNumber: Integer;
    function GetLastDoubleClickedPointLineNumber: Integer;
    procedure ClearPaintedPoints;
    procedure ReFoundPaintedPoints;
    procedure SetAutoEditable(Value: Boolean);
    procedure SetAutoEditMinDistance(Value: Integer);
  protected
    procedure Paint; override;
  public
    ASelectRect,AMainRect : TRect;
    procedure Assign(Source: TPersistent); override;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;

    property Width : integer read GetWidth write SetWidth;
    property Height : integer read GetHeight write SetHeight;
    property Top : integer read GetTop write SetTop;
    property Left : Integer read GetLeft write SetLeft;
    property Color: TColor read GetColor write SetColor;
    property Transparent : Boolean read GetTransparent write SetTransparent;
    property XAxisBegin : double read FXAxisBegin write SetXAxisBegin;
    property XAxisEnd : Double read FXAxisEnd write SetXAxisEnd;
    property YAxisBegin : double read FYAxisBegin write SetYAxisBegin;
    property YAxisEnd  : Double read FYAxisEnd write SetYAxisEnd;
    property YAxis2Begin : Double read FYAxis2Begin write SetYAxis2Begin;
    property YAxis2End : Double read FYAxis2End write SetYAxis2End;
    property XAxisStyle : IAChartBaseAxisStyle read FXAxisStyle write SetXAxisStyle;
    property YAxisStyle : IAChartBaseAxisStyle read FYAxisStyle write SetYAxisStyle;
    property YAxis2Style : IAChartBaseAxisStyle read FYAxis2Style write SetYAxis2Style;
    property XAxisType : IAChartBaseAxisType read FXAxisType write SetXAxisType;
    property ShowGrid : boolean read FShowGrid write SetShowGrid;
    property ColorGridX : TColor read FColorGridX write SetColorGridX;
    property ColorGridY : TColor read FColorGridY write SetColorGridY;
    property ColorGridY2 : TColor read FColorGridY2 write SetColorGridY2;
    property XAxisStep : double read FXAxisStep write SetXAxisStep;
    property YAxisStep : double read FYAxisStep write SetYAxisStep;
    property YAxis2Step : double read FYAxis2Step write SetYAxis2Step;
    property ColorGridBorder : TColor read FColorGridBorder write SetColorGridBorder;

    property MainDataArray : IAChartBaseLineArray read FMainDataArray write SetMainDataArray;
    property LastDoubleClickedPointLineNumber : Integer read GetLastDoubleClickedPointLineNumber;
    property LastDoubleClickedPointDataNumber : Integer read GetLastDoubleClickedPointDataNumber;
    property AutoEditable : Boolean read FAutoEditable write SetAutoEditable;
    property AutoEditMinDistance : Integer read FAutoEditMinDistance write SetAutoEditMinDistance;
  end;

implementation

{ IAChartBaseLinesClass }

procedure IAChartBaseLinesClass.Assign(Source: TPersistent);
begin
  if Source is IAChartBaseLinesClass then
    begin
      YAxis2Begin:=(Source as IAChartBaseLinesClass).FYAxis2Begin;
      YAxisBegin:=(Source as IAChartBaseLinesClass).FYAxisBegin;
      YAxisEnd:=(Source as IAChartBaseLinesClass).FYAxisEnd;
      XAxisBegin:=(Source as IAChartBaseLinesClass).FXAxisBegin;
      XAxisEnd:=(Source as IAChartBaseLinesClass).FXAxisEnd;
      YAxis2End:=(Source as IAChartBaseLinesClass).FYAxis2End;
      YAxis2Style:=(Source as IAChartBaseLinesClass).FYAxis2Style;
      XAxisStyle:=(Source as IAChartBaseLinesClass).FXAxisStyle;
      YAxisStyle:=(Source as IAChartBaseLinesClass).FYAxisStyle;
      XAxisType:=(Source as IAChartBaseLinesClass).FXAxisType;

      ShowGrid:=(Source as IAChartBaseLinesClass).FShowGrid;
      YAxisStep:=(Source as IAChartBaseLinesClass).FYAxisStep;
      YAxis2Step:=(Source as IAChartBaseLinesClass).FYAxis2Step;
      XAxisStep:=(Source as IAChartBaseLinesClass).FXAxisStep;
      ColorGridX:=(Source as IAChartBaseLinesClass).FColorGridX;
      ColorGridY2:=(Source as IAChartBaseLinesClass).FColorGridY2;
      ColorGridY:=(Source as IAChartBaseLinesClass).FColorGridY;
      ColorGridBorder:=(Source as IAChartBaseLinesClass).FColorGridBorder;

      MainDataArray:=(Source as IAChartBaseLinesClass).FMainDataArray;


      AutoEditable:=(Source as IAChartBaseLinesClass).AutoEditable;
      AutoEditMinDistance:=(Source as IAChartBaseLinesClass).AutoEditMinDistance;
      (self as IAChartBaseMovingClass).assign(Source as IAChartBaseMovingClass);

    end else
    begin
      inherited Assign(Source);
    end;
end;

constructor IAChartBaseLinesClass.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  inherited Width:=100;
  inherited Height:=100;
  inherited Color:=$00AfAfAf;
  FAutoEditable:=True;
  FAutoEditMinDistance:=50;
  ClearPaintedPoints;
  transparence:=false;
  FLastDoubleClickedPointLineNumber :=-1;
  FLastDoubleClickedPointDataNumber :=-1;
  FYAxis2Begin:=-1;
  FYAxisBegin:=-1;
  FYAxisEnd:=1;
  FXAxisBegin:=-1;
  FXAxisEnd:=1;
  FYAxis2End:=1;
  FYAxis2Style:=iacbasLinear;
  FXAxisStyle:=iacbasLinear;
  FYAxisStyle:=iacbasLinear;
  FXAxisType:=iacbatHorizontal;
  FShowGrid:=true;
  FYAxisStep:=0;
  FYAxis2Step:=0;
  FXAxisStep:=0;
  FColorGridX:=clBlack;
  FColorGridY2:=clBlack;
  FColorGridY:=clBlack;
  FColorGridBorder:=clBlack;

  FMainDataArray:=IAChartBaseLineArray.Create(self);
end;

destructor IAChartBaseLinesClass.Destroy;
begin
  ClearPaintedPoints;
  FMainDataArray.Free;
  inherited Destroy;
end;

procedure IAChartBaseLinesClass.DrawGrid;
var i : integer;
    APos : Double;
begin
  if FXAxisType = iacbatHorizontal then
    begin
      canvas.Pen.color:=FColorGridX;
      if (FXAxisStep>0) and (width>0)then
        begin
          if FXAxisBegin<FXAxisEnd then
            begin
              APos:=UnderlayInt(FXAxisBegin/FXAxisStep)*FXAxisStep;
              while APos<=FXAxisEnd do
                begin
                  i:=round((APos-FXAxisBegin)*width/(FXAxisEnd-FXAxisBegin));
                  canvas.moveto(i,0);
                  canvas.lineto(i,height-1);
                  APos:=APos+FXAxisStep;
                end;

            end else
            begin
              APos:=UnderlayInt(FXAxisEnd/FXAxisStep)*FXAxisStep;
              while APos<=FXAxisBegin do
                begin
                  i:=round((APos-FXAxisEnd)*width/(FXAxisBegin-FXAxisEnd));
                  canvas.moveto(width-1-i,0);
                  canvas.lineto(width-1-i,height-1);
                  APos:=APos+FXAxisStep;
                end;
            end;
        end;

      canvas.Pen.color:=FColorGridY;
      if (FYAxisStep>0) and (height>0)then
        begin
          if FYAxisBegin<FYAxisEnd then
            begin
              APos:=UnderlayInt(FYAxisBegin/FYAxisStep)*FYAxisStep;
              while APos<=FYAxisEnd do
                begin
                  i:=round((APos-FYAxisBegin)*height/(FYAxisEnd-FYAxisBegin));
                  canvas.moveto(0,height-1-i);
                  canvas.lineto(width-1,height-1-i);
                  APos:=APos+FYAxisStep;
                end;

            end else
            begin
              APos:=UnderlayInt(FYAxisEnd/FYAxisStep)*FYAxisStep;
              while APos<=FYAxisBegin do
                begin
                  i:=round((APos-FYAxisEnd)*height/(FYAxisBegin-FYAxisEnd));
                  canvas.moveto(0,i);
                  canvas.lineto(width-1,i);
                  APos:=APos+FYAxisStep;
                end;
            end;
        end;
      canvas.Pen.color:=FColorGridY2;
      if (FYAxis2Step>0) and (height>0)then
        begin
          if FYAxis2Begin<FYAxis2End then
            begin
              APos:=UnderlayInt(FYAxis2Begin/FYAxis2Step)*FYAxis2Step;
              while APos<=FYAxis2End do
                begin
                  i:=round((APos-FYAxis2Begin)*height/(FYAxis2End-FYAxis2Begin));
                  canvas.moveto(0,height-1-i);
                  canvas.lineto(width-1,height-1-i);
                  APos:=APos+FYAxis2Step;
                end;

            end else
            begin
              APos:=UnderlayInt(FYAxis2End/FYAxis2Step)*FYAxis2Step;
              while APos<=FYAxis2Begin do
                begin
                  i:=round((APos-FYAxis2End)*height/(FYAxis2Begin-FYAxis2End));
                  canvas.moveto(0,i);
                  canvas.lineto(width-1,i);
                  APos:=APos+FYAxis2Step;
                end;
            end;
        end;
    end else
    begin//vert orientation.  of X Axe
      canvas.Pen.color:=FColorGridX;
      if (FXAxisStep>0) and (height>0)then
        begin
          if FXAxisBegin<FXAxisEnd then
            begin
              APos:=UnderlayInt(FXAxisBegin/FXAxisStep)*FXAxisStep;
              while APos<=FXAxisEnd do
                begin
                  i:=round((APos-FXAxisBegin)*height/(FXAxisEnd-FXAxisBegin));
                  canvas.moveto(0,height-1-i);
                  canvas.lineto(width-1,height-1-i);
                  APos:=APos+FXAxisStep;
                end;

            end else
            begin
              APos:=UnderlayInt(FXAxisEnd/FXAxisStep)*FXAxisStep;
              while APos<=FXAxisBegin do
                begin
                  i:=round((APos-FXAxisEnd)*height/(FXAxisBegin-FXAxisEnd));
                  canvas.moveto(0,i);
                  canvas.lineto(width-1,i);
                  APos:=APos+FXAxisStep;
                end;
            end;
        end;

      canvas.Pen.color:=FColorGridY;
      if (FYAxisStep>0) and (width>0)then
        begin
          if FYAxisBegin<FYAxisEnd then
            begin
              APos:=UnderlayInt(FYAxisBegin/FYAxisStep)*FYAxisStep;
              while APos<=FYAxisEnd do
                begin
                  i:=round((APos-FYAxisBegin)*width/(FYAxisEnd-FYAxisBegin));
                  canvas.moveto(i,0);
                  canvas.lineto(i,height-1);
                  APos:=APos+FYAxisStep;
                end;

            end else
            begin
              APos:=UnderlayInt(FYAxisEnd/FYAxisStep)*FYAxisStep;
              while APos<=FYAxisBegin do
                begin
                  i:=round((APos-FYAxisEnd)*width/(FYAxisBegin-FYAxisEnd));
                  canvas.moveto(width-1-i,0);
                  canvas.lineto(width-1-i,height-1);
                  APos:=APos+FYAxisStep;
                end;
            end;
        end;

      canvas.Pen.color:=FColorGridY2;
      if (FYAxis2Step>0) and (width>0)then
        begin
          if FYAxis2Begin<FYAxis2End then
            begin
              APos:=UnderlayInt(FYAxis2Begin/FYAxis2Step)*FYAxis2Step;
              while APos<=FYAxis2End do
                begin
                  i:=round((APos-FYAxis2Begin)*width/(FYAxis2End-FYAxis2Begin));
                  canvas.moveto(i,0);
                  canvas.lineto(i,height-1);
                  APos:=APos+FYAxis2Step;
                end;

            end else
            begin
              APos:=UnderlayInt(FYAxis2End/FYAxis2Step)*FYAxis2Step;
              while APos<=FYAxis2Begin do
                begin
                  i:=round((APos-FYAxis2End)*width/(FYAxis2Begin-FYAxis2End));
                  canvas.moveto(width-1-i,0);
                  canvas.lineto(width-1-i,height-1);
                  APos:=APos+FYAxis2Step;
                end;
            end;
        end;
    end;
  canvas.Pen.color:=FColorGridBorder;
  canvas.brush.Style:=bsClear;
  canvas.Rectangle(0,0,width,height);
  canvas.brush.Style:=bsSolid;
end;

function IAChartBaseLinesClass.GetColor: TColor;
begin
  result:=inherited Color;
end;

function IAChartBaseLinesClass.GetHeight: integer;
begin
  result:=inherited Height;
end;

function IAChartBaseLinesClass.GetLeft: Integer;
begin
  result:=inherited Left;
end;

function IAChartBaseLinesClass.UnderlayInt(AValue: Double): integer;
var SValue : Extended;
begin
  zeromemory(@SValue,10);
  SValue:=AVAlue;
  if SValue<0 then
    begin
      result:=Trunc(SValue)-1;
    end else
    begin
      result:=Trunc(SValue);
    end;
  //if frac(SValue)=0.0 then result:=result-1;
end;

function IAChartBaseLinesClass.GetTop: integer;
begin
  result:=inherited Top;
end;

function IAChartBaseLinesClass.GetTransparent: Boolean;
begin
  result:=Transparence;
end;

function IAChartBaseLinesClass.GetWidth: integer;
begin
  result:=inherited Width;
end;

procedure IAChartBaseLinesClass.Paint;
begin
  if IsMouseDown and not IsSelected then
    begin
      Canvas.pen.width:=3;
      Canvas.pen.mode:=pmNot;
      Canvas.brush.style:=bsClear;
      Canvas.Rectangle(MDownPos.x,MDownPos.y,MUpPos.x,MUpPos.y);
      Canvas.pen.mode:=pmCopy;
      Canvas.pen.width:=1;
      if Transparent then
        begin
          if FShowGrid then DrawGrid;
          MainDataArray.DrawOnCanvas(Canvas);
        end;
    end else
    begin
      if not Transparent then
        begin
          canvas.Brush.color:=Color;
          canvas.FillRect(ClientRect);
        end;
      if FShowGrid then DrawGrid;
      MainDataArray.DrawOnCanvas(Canvas);

      inherited Paint;
    end;
end;

procedure IAChartBaseLinesClass.SetBounds(ALeft, ATop, AWidth,AHeight: Integer);
begin
  if ((Inherited Width)<>AWidth) or ((inherited Height) <>AHeight) then
     begin
       if ((Inherited Top)<>ATop) or ((inherited Left) <>ALeft) then
         begin
           inherited SetBounds(ALeft, ATop, AWidth,AHeight);
           if assigned(parent) and not (csCreating  in Parent.ControlState) and  parent.HandleAllocated
            then postmessage(parent.handle,CM_BASELINESMOVED,cardinal(self),0);
           if assigned(parent) and not (csCreating  in Parent.ControlState) and  parent.HandleAllocated
            then postmessage(parent.handle,CM_BASELINESSIZED,cardinal(self),0);
         end else
         begin
           inherited SetBounds(ALeft, ATop, AWidth,AHeight);
           if assigned(parent) and not (csCreating  in Parent.ControlState) and  parent.HandleAllocated
            then postmessage(parent.handle,CM_BASELINESSIZED,cardinal(self),0);
         end;
     end else
     begin
       if ((Inherited Top)<>ATop) or ((inherited Left) <>ALeft) then
         begin
           inherited SetBounds(ALeft, ATop, AWidth,AHeight);
           if assigned(parent) and not (csCreating  in Parent.ControlState) and  parent.HandleAllocated
            then postmessage(parent.handle,CM_BASELINESMOVED,cardinal(self),0);
         end else
         begin
           inherited SetBounds(ALeft, ATop, AWidth,AHeight);
         end;
     end;
end;

procedure IAChartBaseLinesClass.SetColor(Value: TColor);
begin
  if (inherited Color)<>Value then
    begin
      inherited Color:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetColorGridBorder(Value: TColor);
begin
  if FColorGridBorder<>Value then
    begin
      FColorGridBorder:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetColorGridX(Value: TColor);
begin
  if FColorGridX<>Value then
    begin
      FColorGridX:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetColorGridY(Value: TColor);
begin
  if FColorGridY<>Value then
    begin
      FColorGridY:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetColorGridY2(Value: TColor);
begin
  if FColorGridY2<>Value then
    begin
      FColorGridY2:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetHeight(Value: integer);
begin
  if (inherited Height)<>Value then
    begin
      inherited Height:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetLeft(Value: Integer);
begin
  if (inherited Left)<>Value then
    begin
      inherited Left:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetShowGrid(Value: boolean);
begin
  if FShowGrid<>Value then
    begin
      FShowGrid:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetTop(Value: integer);
begin
  if (inherited Top)<>Value then
    begin
      inherited Top:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetTransparent(Value: Boolean);
begin
  if (Transparence)<>Value then
    begin
      Transparence:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetWidth(Value: integer);
begin
  if (inherited Width)<>Value then
    begin
      inherited Width:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetXAxisBegin(Value: double);
begin
  if FXAxisBegin<>Value then
    begin
      FXAxisBegin:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetXAxisEnd(Value: Double);
begin
if FXAxisEnd<>Value then
    begin
      FXAxisEnd:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetXAxisStep(Value: double);
begin
  if FXAxisStep<>Value then
    begin
      FXAxisStep:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetXAxisStyle(Value: IAChartBaseAxisStyle);
begin
if FXAxisStyle<>Value then
    begin
      FXAxisStyle:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetXAxisType(Value: IAChartBaseAxisType);
begin
if FXAxisType<>Value then
    begin
      FXAxisType:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetYAxis2Begin(Value: Double);
begin
if FYAxis2Begin<>Value then
    begin
      FYAxis2Begin:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetYAxis2End(Value: Double);
begin
if FYAxis2End<>Value then
    begin
      FYAxis2End:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetYAxis2Step(Value: double);
begin
  if FYAxis2Step<>Value then
    begin
      FYAxis2Step:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetYAxis2Style(Value: IAChartBaseAxisStyle);
begin
if FYAxis2Style<>Value then
    begin
      FYAxis2Style:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetYAxisBegin(Value: double);
begin
if FYAxisBegin<>Value then
    begin
      FYAxisBegin:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetYAxisEnd(Value: Double);
begin
if FYAxisEnd<>Value then
    begin
      FYAxisEnd:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetYAxisStep(Value: double);
begin
  if FYAxisStep<>Value then
    begin
      FYAxisStep:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetYAxisStyle(Value: IAChartBaseAxisStyle);
begin
if FYAxisStyle<>Value then
    begin
      FYAxisStyle:=Value;
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.SetMainDataArray(Value: IAChartBaseLineArray);
begin
  if assigned(Value) then
    begin
      FMainDataArray.Assign(Value);
      invalidate;
    end;
end;

procedure IAChartBaseLinesClass.WMLButtonDown(var Message: TWMLButtonDown);
begin
  inherited;
  IsMouseDown:=True;
  MDownPos:=point(Mouse.CursorPos.x-ClientOrigin.x,Mouse.CursorPos.y-ClientOrigin.y);
  MUpPos:=point(Mouse.CursorPos.x-ClientOrigin.x,Mouse.CursorPos.y-ClientOrigin.y);
end;

procedure IAChartBaseLinesClass.WMLButtonUp(var Message: TWMLButtonUp);
begin
  inherited;
  IsMouseDown:=false;

  if (abs(MDownPos.x-MUpPos.x)+abs(MDownPos.y-MUpPos.y))>5 then//defence form trimming
    begin
      ASelectRect:=rect(min(MDownPos.x,MUpPos.x),min(MDownPos.y,MUpPos.y),
                        max(MDownPos.x,MUpPos.x),max(MDownPos.y,MUpPos.y));
      AMainRect:=rect(0,0,width,height);
      if (width>0) and (height>0) then
      postmessage(self.Parent.handle,CM_USERWANTSRESIZE,cardinal(self),0);
    end;
  MUpPos:=point(MDownPos.x,MDownPos.y);
  invalidate;
end;

procedure IAChartBaseLinesClass.WMMouseMove(var Message: TWMMouseMove);
begin
   inherited;
  if IsMouseDown and not IsSelected then
    begin
      Canvas.pen.width:=3;
      Canvas.pen.mode:=pmNot;
      Canvas.brush.style:=bsClear;
      Canvas.Rectangle(MDownPos.x,MDownPos.y,MUpPos.x,MUpPos.y);
      Canvas.pen.mode:=pmCopy;
      Canvas.pen.width:=1;
      MUpPos:=point(Mouse.CursorPos.x-ClientOrigin.x,Mouse.CursorPos.y-ClientOrigin.y);
      repaint;
    end;
end;

procedure IAChartBaseLinesClass.WMLButtonDblClk(var Message: TWMLButtonDblClk);
var x,y,Nline,NData,MinR,R,i,j : integer;
begin
  inherited;
  x:=Mouse.CursorPos.x-ClientOrigin.x;
  y:=Mouse.CursorPos.y-ClientOrigin.y;
  Nline:=-1;
  NData:=-1;
  MinR:=FAutoEditMinDistance;
  for i:=0 to length(FPaintedPoints)-1 do
    begin
      for j:=0 to length(FPaintedPoints[i])-1 do
        begin
          if (FPaintedPoints[i][j][0]>=0) and (FPaintedPoints[i][j][1]>=0) then
            begin
              R:=round(sqrt(sqr(x-FPaintedPoints[i][j][0])+sqr(y-FPaintedPoints[i][j][1])));
              if R<=MinR then
                begin
                  MinR:=R;
                  NLine:=i;
                  NData:=j;
                end;
            end;
        end;
    end;
  FLastDoubleClickedPointLineNumber:=NLine;
  FLastDoubleClickedPointDataNumber:=NData;


  if FAutoEditable then
    begin
      IAChartBaseLinesEditWindow:=TIAChartBaseLinesEditWindow.Create(self);
      IAChartBaseLinesEditWindow.FCurrControl:=self;
      IAChartBaseLinesEditWindow.ShowModal;
      case IAChartBaseLinesEditWindow.ModalResult of
        mrNone,mrCancel :
          begin
            IAChartBaseLinesEditWindow.release;
          end;
        mrOk   :
          begin
            IAChartBaseLinesEditWindow.BackUpdate;
            IAChartBaseLinesEditWindow.release;
          end;
        else
          begin
            IAChartBaseLinesEditWindow.release;
          end;
      end;
    end;
end;

function IAChartBaseLinesClass.GetLastDoubleClickedPointDataNumber: Integer;
begin
  result:=FLastDoubleClickedPointDataNumber;
end;

function IAChartBaseLinesClass.GetLastDoubleClickedPointLineNumber: Integer;
begin
  result:=FLastDoubleClickedPointLineNumber;
end;

procedure IAChartBaseLinesClass.ClearPaintedPoints;
var i : integer;
begin
  if length(FPaintedPoints)>0 then
    begin
      for i:=0 to length(FPaintedPoints)-1 do
        begin
          if length(FPaintedPoints[i])>0 then  setlength(FPaintedPoints[i],0);
        end;
      setlength(FPaintedPoints,0);
    end;
end;

procedure IAChartBaseLinesClass.ReFoundPaintedPoints;
var i,j : integer;
begin
  if self.FMainDataArray.FLinesNumber>0 then
    begin
      setlength(FPaintedPoints,self.FMainDataArray.FLinesNumber);
        for i:=0 to length(FPaintedPoints)-1 do
        begin
          if FMainDataArray.FdataNumber>0 then
            begin
              setlength(FPaintedPoints[i],FMainDataArray.FdataNumber);
              for j:=0 to FMainDataArray.FdataNumber-1 do
                begin
                  FPaintedPoints[i][j][0]:=-1;
                  FPaintedPoints[i][j][1]:=-1;
                end;
            end;
        end;
    end;
end;

procedure IAChartBaseLinesClass.SetAutoEditable(Value: Boolean);
begin
  FAutoEditable := Value;
end;

procedure IAChartBaseLinesClass.SetAutoEditMinDistance(Value: Integer);
begin
  FAutoEditMinDistance := Value;
end;

{ IAChartBaseLinesClassData }

procedure IAChartBaseLinesClassData.Assign(Source: TPersistent);
begin
  if Source is IAChartBaseLinesClassData then
    begin
      Transparent:=(Source as IAChartBaseLinesClassData).Transparent;
      Color:=(Source as IAChartBaseLinesClassData).Color;
      Width:=(Source as IAChartBaseLinesClassData).Width;
      Height:=(Source as IAChartBaseLinesClassData).Height;
      Top:=(Source as IAChartBaseLinesClassData).Top;
      Left:=(Source as IAChartBaseLinesClassData).Left;
      SizeAble:=(Source as IAChartBaseLinesClassData).SizeAble;
      Selectable:=(Source as IAChartBaseLinesClassData).Selectable;
      MoveAble:=(Source as IAChartBaseLinesClassData).MoveAble;

      ShowGrid:=(Source as IAChartBaseLinesClassData).ShowGrid;
      ColorGridX:=(Source as IAChartBaseLinesClassData).ColorGridX;
      ColorGridY2:=(Source as IAChartBaseLinesClassData).ColorGridY2;
      ColorGridY:=(Source as IAChartBaseLinesClassData).ColorGridY;
      ColorGridBorder:=(Source as IAChartBaseLinesClassData).ColorGridBorder;
      MainDataArray:=(Source as IAChartBaseLinesClassData).MainDataArray;
      AutoEditable:=(Source as IAChartBaseLinesClassData).AutoEditable;
      AutoEditMinDistance:=(Source as IAChartBaseLinesClassData).AutoEditMinDistance;
    end else
    begin
      inherited Assign(Source);
    end;
end;

constructor IAChartBaseLinesClassData.Create(AOwner: TComponent);
begin
 inherited Create;
 FLinesField:=IAChartBaseLinesClass.Create(AOwner as TWinControl);
 FLinesField.Parent:=AOwner as TWinControl;
end;

destructor IAChartBaseLinesClassData.Destroy;
begin
  FLinesField.free;
  inherited Destroy;
end;

function IAChartBaseLinesClassData.GetAutoEditable: Boolean;
begin
  result:=FLinesField.AutoEditable;
end;

function IAChartBaseLinesClassData.GetAutoEditMinDistance: Integer;
begin
  result:=FLinesField.AutoEditMinDistance;
end;

function IAChartBaseLinesClassData.GetColor: TColor;
begin
  result:=FLinesField.Color;
end;

function IAChartBaseLinesClassData.GetColorGridBorder: TColor;
begin
  result:=FLinesField.ColorGridBorder;
end;

function IAChartBaseLinesClassData.GetColorGridX: TColor;
begin
  result:=FLinesField.ColorGridX;
end;

function IAChartBaseLinesClassData.GetColorGridY: TColor;
begin
  result:=FLinesField.ColorGridY;
end;

function IAChartBaseLinesClassData.GetColorGridY2: TColor;
begin
  result:=FLinesField.ColorGridY2;
end;

function IAChartBaseLinesClassData.GetHeight: integer;
begin
  result:=FLinesField.Height;
end;

function IAChartBaseLinesClassData.GetLastDoubleClickedPointDataNumber: Integer;
begin
  result:=FLinesField.LastDoubleClickedPointDataNumber;
end;

function IAChartBaseLinesClassData.GetLastDoubleClickedPointLineNumber: Integer;
begin
  result:=FLinesField.LastDoubleClickedPointDataNumber;
end;

function IAChartBaseLinesClassData.GetLeft: Integer;
begin
  result:=FLinesField.Left;
end;

function IAChartBaseLinesClassData.GetMainDataArray: IAChartBaseLineArray;
begin
  result:=FLinesField.MainDataArray;
end;

function IAChartBaseLinesClassData.GetMoveAble: Boolean;
begin
  result:=FLinesField.MoveAble;
end;

function IAChartBaseLinesClassData.GetSelectable: Boolean;
begin
  result:=FLinesField.Selectable;
end;

function IAChartBaseLinesClassData.GetShowGrid: boolean;
begin
  result:=FLinesField.ShowGrid;
end;

function IAChartBaseLinesClassData.GetSizeAble: Boolean;
begin
  result:=FLinesField.SizeAble;
end;

function IAChartBaseLinesClassData.GetTop: integer;
begin
  result:=FLinesField.Top;
end;

function IAChartBaseLinesClassData.GetTransparent: Boolean;
begin
  result:=FLinesField.Transparent;
end;

function IAChartBaseLinesClassData.GetWidth: integer;
begin
  result:=FLinesField.Width;
end;

procedure IAChartBaseLinesClassData.SetAutoEditable(Value: Boolean);
begin
  FLinesField.AutoEditable:=Value;
end;

procedure IAChartBaseLinesClassData.SetAutoEditMinDistance( Value: Integer);
begin
   FLinesField.AutoEditMinDistance:=Value;
end;

procedure IAChartBaseLinesClassData.SetColor(Value: TColor);
begin
  FLinesField.Color:=Value;
end;

procedure IAChartBaseLinesClassData.SetColorGridBorder(Value: TColor);
begin
    FLinesField.ColorGridBorder:=Value;
end;

procedure IAChartBaseLinesClassData.SetColorGridX(Value: TColor);
begin
  FLinesField.ColorGridX:=Value;
end;

procedure IAChartBaseLinesClassData.SetColorGridY(Value: TColor);
begin
  FLinesField.ColorGridY:=Value;
end;

procedure IAChartBaseLinesClassData.SetColorGridY2(Value: TColor);
begin
  FLinesField.ColorGridY2:=Value;
end;

procedure IAChartBaseLinesClassData.SetHeight(Value: integer);
begin
  FLinesField.Height:=Value;
end;

procedure IAChartBaseLinesClassData.SetLeft(Value: Integer);
begin
  FLinesField.Left:=Value;
end;

procedure IAChartBaseLinesClassData.SetMainDataArray(Value: IAChartBaseLineArray);
begin
  FLinesField.MainDataArray:=Value;
end;

procedure IAChartBaseLinesClassData.SetMoveAble(Value: Boolean);
begin
  FLinesField.MoveAble:=Value;
end;

procedure IAChartBaseLinesClassData.SetSelectable(Value: Boolean);
begin
  FLinesField.Selectable:=Value;
end;

procedure IAChartBaseLinesClassData.SetShowGrid(Value: boolean);
begin
  FLinesField.ShowGrid:=Value;
end;

procedure IAChartBaseLinesClassData.SetSizeAble(Value: Boolean);
begin
  FLinesField.SizeAble:=Value;
end;

procedure IAChartBaseLinesClassData.SetTop(Value: integer);
begin
  FLinesField.Top:=Value;
end;

procedure IAChartBaseLinesClassData.SetTransparent(Value: Boolean);
begin
  FLinesField.Transparent:=Value;
end;

procedure IAChartBaseLinesClassData.SetWidth(Value: integer);
begin
  FLinesField.Width:=Value;
end;

{ IAChartBaseLine }

procedure IAChartBaseLine.Assign(Source: TPersistent);
begin
    if Source is IAChartBaseLine then
    begin
      Number:=(Source as IAChartBaseLine).FNumber;
      Data:=(Source as IAChartBaseLine).FData;
      PointType:=(Source as IAChartBaseLine).PointType;
      LineType:=(Source as IAChartBaseLine).LineType;
      PointColor:=(Source as IAChartBaseLine).PointColor;
      PointSize:=(Source as IAChartBaseLine).PointSize;

      XLine:=(Source as IAChartBaseLine).FXLine;
      YsubLine:=(Source as IAChartBaseLine).FYsubLine;
      YaddLine:=(Source as IAChartBaseLine).FYaddLine;
      XaddLine:=(Source as IAChartBaseLine).FXaddLine;
      XsubLine:=(Source as IAChartBaseLine).FXsubLine;

      LineStyle:=(Source as IAChartBaseLine).LineStyle;
      LineColor:=(Source as IAChartBaseLine).LineColor;
      DiapasonType:=(Source as IAChartBaseLine).DiapasonType;
      DiapasonColor:=(Source as IAChartBaseLine).DiapasonColor;
      InfoString:=(Source as IAChartBaseLine).InfoString;
    end else
    begin
      inherited Assign(Source);
    end;
end;

constructor IAChartBaseLine.Create(AOwner: TComponent);
begin
  inherited Create;
  FOwner:=AOwner;
  FNumber:=0;
  setlength(FData,0);

  FXLine:=-1;
  FYsubLine:=-1;
  FYaddLine:=-1;
  FXaddLine:=-1;
  FXsubLine:=-1;
  FPointType:=iacblptNone;
  FLineType:=iacbltYData;
  FPointColor:=clBlack;
  FPointSize:=10;

  FLineColor:=clBlack;
  FLineStyle:=iacblsLine;

  FDiapasonType:=iacbldtCross;
  FDiapasonColor:=clBlack;
  FInfoString:='One of the Lines';
end;

destructor IAChartBaseLine.Destroy;
begin
  setlength(FData,0);
  inherited Destroy;
end;

procedure IAChartBaseLine.SetData(Value: IAChartDataArray);
begin
  if (Value<>nil) and (FNumber=length(Value))then
    begin
      copymemory(@(FData[low(FData)]),@(Value[low(Value)]),FNumber*8);
      if (FOwner is IAChartBaseLinesClass) and assigned((FOwner as IAChartBaseLinesClass).parent) and
        ((FOwner as IAChartBaseLinesClass).parent.handleALlocated) then
        begin
          postMessage((FOwner as IAChartBaseLinesClass).parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);
        end;
      //CM_USERCHANGELINESREPRESENTATION
    end;
end;

procedure IAChartBaseLine.SetDiapasonColor(Value: TColor);
begin
  if FDiapasonColor<>Value then
    begin
      FDiapasonColor := Value;
      if (FOwner is IAChartBaseLinesClass) and assigned((FOwner as IAChartBaseLinesClass).parent) and
        ((FOwner as IAChartBaseLinesClass).parent.handleALlocated) then
        begin
          postMessage((FOwner as IAChartBaseLinesClass).parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);
          (FOwner as IAChartBaseLinesClass).invalidate;
        end;

    end;
end;

procedure IAChartBaseLine.SetDiapasonType(Value: IAChartBaseLineDiapasonType);
begin
  if FDiapasonType<>Value then
    begin
      FDiapasonType := Value;
      if (FOwner is IAChartBaseLinesClass) and assigned((FOwner as IAChartBaseLinesClass).parent) and
        ((FOwner as IAChartBaseLinesClass).parent.handleALlocated) then
        begin
          postMessage((FOwner as IAChartBaseLinesClass).parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);
          (FOwner as IAChartBaseLinesClass).invalidate;
        end;

    end;
end;

procedure IAChartBaseLine.SetInfoString(Value: string);
begin
  if FInfoString<>value then
    begin
      FInfoString := Value;
      if (FOwner is IAChartBaseLinesClass) and assigned((FOwner as IAChartBaseLinesClass).parent) and
        ((FOwner as IAChartBaseLinesClass).parent.handleALlocated) then
        begin
          postMessage((FOwner as IAChartBaseLinesClass).parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);
        end;
    end;
end;

procedure IAChartBaseLine.SetLineColor(Value: TColor);
begin
  if FLineColor<>Value then
    begin
      FLineColor := Value;
      if (FOwner is IAChartBaseLinesClass) and assigned((FOwner as IAChartBaseLinesClass).parent) and
        ((FOwner as IAChartBaseLinesClass).parent.handleALlocated) then
        begin
          postMessage((FOwner as IAChartBaseLinesClass).parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);
          (FOwner as IAChartBaseLinesClass).invalidate;
        end;

    end;
end;

procedure IAChartBaseLine.SetLineStyle(Value: IAChartBaseLineStyle);
begin
  if FLineStyle<>Value then
    begin
      FLineStyle := Value;
      if (FOwner is IAChartBaseLinesClass) and assigned((FOwner as IAChartBaseLinesClass).parent) and
        ((FOwner as IAChartBaseLinesClass).parent.handleALlocated) then
        begin
          postMessage((FOwner as IAChartBaseLinesClass).parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);
          (FOwner as IAChartBaseLinesClass).invalidate;
        end;

    end;
end;

procedure IAChartBaseLine.SetLineType(Value: IAChartBaseLineType);
begin
  FLineType := Value;
  if (FOwner is IAChartBaseLinesClass) and assigned((FOwner as IAChartBaseLinesClass).parent) and
    ((FOwner as IAChartBaseLinesClass).parent.handleALlocated) then
    begin
      postMessage((FOwner as IAChartBaseLinesClass).parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);
      (FOwner as IAChartBaseLinesClass).invalidate;
    end;

end;

procedure IAChartBaseLine.SetNumber(Value: Integer);
begin
  if (Value<>FNumber) and (Value>=0) then
    begin
      FNumber := Value;
      setlength(FData,0);
      if FNumber>0 then
        begin
          setlength(FData,FNumber);
          zeromemory(@(FData[low(FData)]),FNumber*8);
        end;
      if (FOwner is IAChartBaseLinesClass) and  assigned((FOwner as IAChartBaseLinesClass).parent) and
        ((FOwner as IAChartBaseLinesClass).parent.handleALlocated) then
        begin
          postMessage((FOwner as IAChartBaseLinesClass).parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);
        end;
    end;
end;

procedure IAChartBaseLine.SetPointColor(Value: TColor);
begin
  if FPointColor<>value then
    begin
      FPointColor := Value;
      if (FOwner is IAChartBaseLinesClass) and assigned((FOwner as IAChartBaseLinesClass).parent) and
        ((FOwner as IAChartBaseLinesClass).parent.handleALlocated) then
        begin
          postMessage((FOwner as IAChartBaseLinesClass).parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);  
          (FOwner as IAChartBaseLinesClass).invalidate;
        end;

    end;
end;

procedure IAChartBaseLine.SetPointSize(Value: Byte);
begin
  if FPointSize<>value then
    begin
      FPointSize := Value;
      if (FOwner is IAChartBaseLinesClass) and assigned((FOwner as IAChartBaseLinesClass).parent) and
        ((FOwner as IAChartBaseLinesClass).parent.handleALlocated) then
        begin
          postMessage((FOwner as IAChartBaseLinesClass).parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);
          (FOwner as IAChartBaseLinesClass).invalidate;
        end;

    end;
end;

procedure IAChartBaseLine.SetPointType(Value: IAChartBaseLinePointType);
begin
  if FPointType<>value then
    begin
      FPointType := Value;
      if (FOwner is IAChartBaseLinesClass) and assigned((FOwner as IAChartBaseLinesClass).parent) and
        ((FOwner as IAChartBaseLinesClass).parent.handleALlocated) then
        begin
          postMessage((FOwner as IAChartBaseLinesClass).parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);
          (FOwner as IAChartBaseLinesClass).invalidate;
        end;

    end;
end;




procedure IAChartBaseLine.SetXaddLine(Value: Integer);
begin
  if FXaddLine<>value then
    begin
      FXaddLine := Value;
       if (FOwner is IAChartBaseLinesClass) then
      (FOwner as IAChartBaseLinesClass).invalidate;
    end;
end;

procedure IAChartBaseLine.SetXLine(Value: Integer);
begin
  if FXLine<>value then
    begin
      FXLine := Value;
      if (FOwner is IAChartBaseLinesClass) then
      (FOwner as IAChartBaseLinesClass).invalidate;
    end;
end;

procedure IAChartBaseLine.SetXsubLine(Value: Integer);
begin
  if FXsubLine<>value then
    begin
      FXsubLine := Value;
      if (FOwner is IAChartBaseLinesClass) then
      (FOwner as IAChartBaseLinesClass).invalidate;
    end;
end;

procedure IAChartBaseLine.SetYaddLine(Value: Integer);
begin
  if FYaddLine<>value then
    begin
      FYaddLine := Value;
      if (FOwner is IAChartBaseLinesClass) then
      (FOwner as IAChartBaseLinesClass).invalidate;
    end;
end;

procedure IAChartBaseLine.SetYsubLine(Value: Integer);
begin
  if FYsubLine<>value then
    begin
      FYsubLine := Value;
      if (FOwner is IAChartBaseLinesClass) then
      (FOwner as IAChartBaseLinesClass).invalidate;
    end;
end;

{ IAChartBaseLineArray }

procedure IAChartBaseLineArray.Assign(Source: TPersistent);
begin
  if Source is IAChartBaseLineArray then
    begin
      DataNumber:=(Source as IAChartBaseLineArray).DataNumber;
      LinesNumber:=(Source as IAChartBaseLineArray).LinesNumber;
      Lines:=(Source as IAChartBaseLineArray).Lines;
      CommonInfo:=(Source as IAChartBaseLineArray).CommonInfo;
    end else
    begin
      inherited Assign(Source);
    end;
end;

constructor IAChartBaseLineArray.Create(AOwner: TComponent);
begin
  inherited Create;
  FOwner:=AOwner;
  setlength(FLines,0);
  FDataNumber:=0;
  FLinesNumber:=0;
  FCommonInfo:='Lines Info :';
end;

destructor IAChartBaseLineArray.Destroy;
var i : integer;
begin
  for i:=0 to FLinesNumber-1 do
    begin
      FLines[i].free;
    end;
  setlength(FLines,0);
  inherited Destroy;
end;

procedure IAChartBaseLineArray.DrawOnCanvas(ACanvas: TCanvas);
var i,x,y,j,xp,yp,xn,yn,xn2,yn2 : integer;
    CurrLine : IAChartBaseLine;
    ParReg : IAChartBaseLinesClass;
    XVal,YVal,XvalPred,XValNext,YvalPred,YvalNext,XValNext2,YvalNext2 : double;
    XvalDo,XvalPo,YvalDo,YvalPo : Double;
    DipRect : TRect;
begin

  ParReg:=(FOwner as IAChartBaseLinesClass);
  Parreg.ClearPaintedPoints;
  Parreg.ReFoundPaintedPoints;
  //Draw the lInes
  for i:=0 to FLinesNumber-1 do
    begin
      CurrLine:=FLines[i];
      case CurrLine.LineType of
        iacbltYData :
          begin
            if ParReg.XAxisType=iacbatHorizontal then
              begin
                for j:=0 to FDataNumber-1 do
                  begin
                    if (CurrLine.XLine>=0) and (CurrLine.XLine<FLinesNumber) then
                      begin
                        XVal:=FLines[CurrLine.XLine].data[j];
                        if j>0                then XValPred:=FLines[CurrLine.XLine].data[j-1] else XValPred:=XVal;
                        if j<(FDataNumber-1) then XValNext:=FLines[CurrLine.XLine].data[j+1] else XValNext:=Xval;
                        if j<(FDataNumber-2) then XValNext2:=FLines[CurrLine.XLine].data[j+2] else XValNext2:=XValNext;
                      end else
                      begin
                        xval:=j;
                        if j>0                then XValPred:=j-1 else  XValPred:=XVal;
                        if j<(FDataNumber-1) then XValNext:=j+1  else XValNext:=Xval;
                        if j<(FDataNumber-2) then XValNext2:=j+2  else XValNext2:=XValNext;
                      end;
                    YVal:=CurrLine.data[j];
                    if j>0                then YValPred:=CurrLine.data[j-1]  else YValPred:=CurrLine.data[j];
                    if j<(FDataNumber-1) then YValNext:=CurrLine.data[j+1]  else YValNext:=CurrLine.data[j];
                    if j<(FDataNumber-2) then YValNext2:=CurrLine.data[j+2]  else YValNext2:=YValNext;
                    X:=round(ParReg.Width*(XVal-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Y:=ParReg.height-round(ParReg.height*(YVal-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin));
                    Xp:=round(ParReg.Width*(XValPred-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Yp:=ParReg.height-round(ParReg.height*(YValPred-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin));
                    Xn:=round(ParReg.Width*(XValNext-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Yn:=ParReg.height-round(ParReg.height*(YValNext-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin));
                    Xn2:=round(ParReg.Width*(XValNext2-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Yn2:=ParReg.height-round(ParReg.height*(YValNext2-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin));
                    if ptinrect(ParReg.clientrect,point(x,y)) then
                    case CurrLine.LineStyle of
                      iacblsNone :
                        begin

                        end;
                      iacblsLine :
                        begin
                          if ptinrect(ParReg.clientrect,point(xp,yp)) then
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              ACanvas.MoveTo(x,y);
                              ACanvas.LineTo(xn,yn);


                            end else
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              ACanvas.MoveTo(xp,yp);
                              ACanvas.LineTo(x,y);
                              ACanvas.LineTo(xn,yn);
                            end;
                        end;
                      iacblsSpline :
                        begin
                          if ptinrect(ParReg.clientrect,point(xp,yp)) then
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              DrawSpline(ACanvas,xp,x,xn,xn2,yp,y,yn,yn2);


                            end else
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              DrawSpline(ACanvas,xp,xp,x,xn,yp,yp,y,yn);
                              DrawSpline(ACanvas,xp,x,xn,xn2,yp,y,yn,yn2);
                            end;

                        end;
                    end;
                  end;
              end else
              begin
                for j:=0 to FDataNumber-1 do
                  begin
                    if (CurrLine.XLine>=0) and (CurrLine.XLine<FLinesNumber) then
                      begin
                        XVal:=FLines[CurrLine.XLine].data[j];
                        if j>0                then XValPred:=FLines[CurrLine.XLine].data[j-1] else XValPred:=XVal;
                        if j<(FDataNumber-1) then XValNext:=FLines[CurrLine.XLine].data[j+1] else XValNext:=Xval;
                        if j<(FDataNumber-2) then XValNext2:=FLines[CurrLine.XLine].data[j+2] else XValNext2:=XValNext;
                      end else
                      begin
                        xval:=j;
                        if j>0                then XValPred:=j-1 else  XValPred:=XVal;
                        if j<(FDataNumber-1) then XValNext:=j+1  else XValNext:=Xval;
                        if j<(FDataNumber-2) then XValNext2:=j+2  else XValNext2:=XValNext;
                      end;
                    YVal:=CurrLine.data[j];
                    if j>0                then YValPred:=CurrLine.data[j-1]  else YValPred:=CurrLine.data[j];
                    if j<(FDataNumber-1) then YValNext:=CurrLine.data[j+1]  else YValNext:=CurrLine.data[j];
                    if j<(FDataNumber-2) then YValNext2:=CurrLine.data[j+2]  else YValNext2:=YValNext;

                    Y:=ParReg.height-round(ParReg.height*(XVal-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    X:=round(ParReg.Width*(YVal-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin));
                    Yp:=ParReg.height-round(ParReg.height*(XValPred-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Xp:=round(ParReg.Width*(YValPred-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin));
                    Yn:=ParReg.height-round(ParReg.height*(XValNext-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Xn:=round(ParReg.Width*(YValNext-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin));
                    Yn2:=ParReg.height-round(ParReg.height*(XValNext2-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Xn2:=round(ParReg.Width*(YValNext2-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin));
                    if ptinrect(ParReg.clientrect,point(x,y)) then
                    case CurrLine.LineStyle of
                      iacblsNone :
                        begin

                        end;
                      iacblsLine :
                        begin
                          if ptinrect(ParReg.clientrect,point(xp,yp)) then
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              ACanvas.MoveTo(x,y);
                              ACanvas.LineTo(xn,yn);


                            end else
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              ACanvas.MoveTo(xp,yp);
                              ACanvas.LineTo(x,y);
                              ACanvas.LineTo(xn,yn);
                            end;
                        end;
                      iacblsSpline :
                        begin
                          if ptinrect(ParReg.clientrect,point(xp,yp)) then
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              DrawSpline(ACanvas,xp,x,xn,xn2,yp,y,yn,yn2);


                            end else
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              DrawSpline(ACanvas,xp,xp,x,xn,yp,yp,y,yn);
                              DrawSpline(ACanvas,xp,x,xn,xn2,yp,y,yn,yn2);
                            end;
                        end;
                    end;
                  end;
              end;
          end;
        iacbltY2Data :
          begin
            if ParReg.XAxisType=iacbatHorizontal then
              begin
                for j:=0 to FDataNumber-1 do
                  begin
                    if (CurrLine.XLine>=0) and (CurrLine.XLine<FLinesNumber) then
                      begin
                        XVal:=FLines[CurrLine.XLine].data[j];
                        if j>0                then XValPred:=FLines[CurrLine.XLine].data[j-1] else XValPred:=XVal;
                        if j<(FDataNumber-1) then XValNext:=FLines[CurrLine.XLine].data[j+1] else XValNext:=Xval;
                        if j<(FDataNumber-2) then XValNext2:=FLines[CurrLine.XLine].data[j+2] else XValNext2:=XValNext;
                      end else
                      begin
                        xval:=j;
                        if j>0                then XValPred:=j-1 else  XValPred:=XVal;
                        if j<(FDataNumber-1) then XValNext:=j+1  else XValNext:=Xval;
                        if j<(FDataNumber-2) then XValNext2:=j+2  else XValNext2:=XValNext;
                      end;
                    YVal:=CurrLine.data[j];
                    if j>0                then YValPred:=CurrLine.data[j-1]  else YValPred:=CurrLine.data[j];
                    if j<(FDataNumber-1) then YValNext:=CurrLine.data[j+1]  else YValNext:=CurrLine.data[j];
                    if j<(FDataNumber-2) then YValNext2:=CurrLine.data[j+2]  else YValNext2:=YValNext;
                    X:=round(ParReg.Width*(XVal-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Y:=ParReg.height-round(ParReg.height*(YVal-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin));
                    Xp:=round(ParReg.Width*(XValPred-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Yp:=ParReg.height-round(ParReg.height*(YValPred-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin));
                    Xn:=round(ParReg.Width*(XValNext-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Yn:=ParReg.height-round(ParReg.height*(YValNext-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin));
                    Xn2:=round(ParReg.Width*(XValNext2-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Yn2:=ParReg.height-round(ParReg.height*(YValNext2-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin));
                    if ptinrect(ParReg.clientrect,point(x,y)) then
                    case CurrLine.LineStyle of
                      iacblsNone :
                        begin

                        end;
                      iacblsLine :
                        begin
                          if ptinrect(ParReg.clientrect,point(xp,yp)) then
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              ACanvas.MoveTo(x,y);
                              ACanvas.LineTo(xn,yn);


                            end else
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              ACanvas.MoveTo(xp,yp);
                              ACanvas.LineTo(x,y);
                              ACanvas.LineTo(xn,yn);
                            end;
                        end;
                      iacblsSpline :
                        begin
                          if ptinrect(ParReg.clientrect,point(xp,yp)) then
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              DrawSpline(ACanvas,xp,x,xn,xn2,yp,y,yn,yn2);


                            end else
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              DrawSpline(ACanvas,xp,xp,x,xn,yp,yp,y,yn);
                              DrawSpline(ACanvas,xp,x,xn,xn2,yp,y,yn,yn2);
                            end;
                        end;
                    end;
                  end;
              end else
              begin
                for j:=0 to FDataNumber-1 do
                  begin
                    if (CurrLine.XLine>=0) and (CurrLine.XLine<FLinesNumber) then
                      begin
                        XVal:=FLines[CurrLine.XLine].data[j];
                        if j>0                then XValPred:=FLines[CurrLine.XLine].data[j-1] else XValPred:=XVal;
                        if j<(FDataNumber-1) then XValNext:=FLines[CurrLine.XLine].data[j+1] else XValNext:=Xval;
                        if j<(FDataNumber-2) then XValNext2:=FLines[CurrLine.XLine].data[j+2] else XValNext2:=XValNext;
                      end else
                      begin
                        xval:=j;
                        if j>0                then XValPred:=j-1 else  XValPred:=XVal;
                        if j<(FDataNumber-1) then XValNext:=j+1  else XValNext:=Xval;
                        if j<(FDataNumber-2) then XValNext2:=j+2  else XValNext2:=XValNext;
                      end;
                    YVal:=CurrLine.data[j];
                    if j>0                then YValPred:=CurrLine.data[j-1]  else YValPred:=CurrLine.data[j];
                    if j<(FDataNumber-1) then YValNext:=CurrLine.data[j+1]  else YValNext:=CurrLine.data[j];
                    if j<(FDataNumber-2) then YValNext2:=CurrLine.data[j+2]  else YValNext2:=YValNext;

                    Y:=ParReg.height-round(ParReg.height*(XVal-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    X:=round(ParReg.Width*(YVal-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin));
                    Yp:=ParReg.height-round(ParReg.height*(XValPred-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Xp:=round(ParReg.Width*(YValPred-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin));
                    Yn:=ParReg.height-round(ParReg.height*(XValNext-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Xn:=round(ParReg.Width*(YValNext-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin));
                    Yn2:=ParReg.height-round(ParReg.height*(XValNext2-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Xn2:=round(ParReg.Width*(YValNext2-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin));
                    if ptinrect(ParReg.clientrect,point(x,y)) then
                    case CurrLine.LineStyle of
                      iacblsNone :
                        begin

                        end;
                      iacblsLine :
                        begin
                          if ptinrect(ParReg.clientrect,point(xp,yp)) then
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              ACanvas.MoveTo(x,y);
                              ACanvas.LineTo(xn,yn);


                            end else
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              ACanvas.MoveTo(xp,yp);
                              ACanvas.LineTo(x,y);
                              ACanvas.LineTo(xn,yn);
                            end;
                        end;
                      iacblsSpline :
                        begin
                          if ptinrect(ParReg.clientrect,point(xp,yp)) then
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              DrawSpline(ACanvas,xp,x,xn,xn2,yp,y,yn,yn2);


                            end else
                            begin
                              ACanvas.pen.color:=CurrLine.LineColor;
                              DrawSpline(ACanvas,xp,xp,x,xn,yp,yp,y,yn);
                              DrawSpline(ACanvas,xp,x,xn,xn2,yp,y,yn,yn2);
                            end;
                        end;
                    end;
                  end;
              end;
          end;
      end;

    end;


  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //Draw the points
  for i:=0 to FLinesNumber-1 do
    begin
      CurrLine:=FLines[i];
      case CurrLine.LineType of
        iacbltYData :
          begin
            if ParReg.XAxisType=iacbatHorizontal then
              begin
                for j:=0 to FDataNumber-1 do
                  begin
                    if (CurrLine.XLine>=0) and (CurrLine.XLine<FLinesNumber) then
                      begin
                        XVal:=FLines[CurrLine.XLine].data[j];
                      end else
                      begin
                        xval:=j;
                      end;
                    YVal:=CurrLine.data[j];
                    X:=round(ParReg.Width*(XVal-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Y:=ParReg.height-round(ParReg.height*(YVal-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin));
                    if ptinrect(ParReg.clientrect,point(x,y)) then
                    case CurrLine.PointType of
                      iacblptNone :
                        begin
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                      iacblptCircle :
                        begin
                          ACanvas.pen.color:=CurrLine.PointColor;
                          ACanvas.brush.Style:=bsClear;
                          ACanvas.Ellipse(x-CurrLine.PointSize div 2,y-CurrLine.PointSize div 2,
                                          x+CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.brush.Style:=bsSolid;
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                      iacblptSquare :
                        begin
                          ACanvas.pen.color:=CurrLine.PointColor;
                          ACanvas.brush.Style:=bsClear;
                          ACanvas.Rectangle(x-CurrLine.PointSize div 2,y-CurrLine.PointSize div 2,
                                          x+CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.brush.Style:=bsSolid;
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                      iacblptTriangle :
                        begin
                          ACanvas.pen.color:=CurrLine.PointColor;
                          ACanvas.brush.Style:=bsClear;
                          ACanvas.MoveTo(x,y-CurrLine.PointSize div 2);
                          ACanvas.LineTo(x+CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.LineTo(x-CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.LineTo(x,y-CurrLine.PointSize div 2);
                          ACanvas.brush.Style:=bsSolid;
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                    end;
                  end;
              end else
              begin
                for j:=0 to FDataNumber-1 do
                  begin
                    if (CurrLine.XLine>=0) and (CurrLine.XLine<FLinesNumber) then
                      begin
                        XVal:=FLines[CurrLine.XLine].data[j];
                      end else
                      begin
                        xval:=j;
                      end;
                    YVal:=CurrLine.data[j];
                    Y:=ParReg.height-round(ParReg.height*(XVal-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    X:=round(ParReg.Width*(YVal-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin));

                    if ptinrect(ParReg.clientrect,point(x,y)) then
                    case CurrLine.PointType of
                      iacblptNone :
                        begin
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                      iacblptCircle :
                        begin
                          ACanvas.pen.color:=CurrLine.PointColor;
                          ACanvas.brush.Style:=bsClear;
                          ACanvas.Ellipse(x-CurrLine.PointSize div 2,y-CurrLine.PointSize div 2,
                                          x+CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.brush.Style:=bsSolid;
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                      iacblptSquare :
                        begin
                          ACanvas.pen.color:=CurrLine.PointColor;
                          ACanvas.brush.Style:=bsClear;
                          ACanvas.Rectangle(x-CurrLine.PointSize div 2,y-CurrLine.PointSize div 2,
                                          x+CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.brush.Style:=bsSolid;
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                      iacblptTriangle :
                        begin
                          ACanvas.pen.color:=CurrLine.PointColor;
                          ACanvas.brush.Style:=bsClear;
                          ACanvas.MoveTo(x,y-CurrLine.PointSize div 2);
                          ACanvas.LineTo(x+CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.LineTo(x-CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.LineTo(x,y-CurrLine.PointSize div 2);
                          ACanvas.brush.Style:=bsSolid;
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                    end;
                  end;

              end;
          end;
        iacbltY2Data :
          begin
            if ParReg.XAxisType=iacbatHorizontal then
              begin
                for j:=0 to FDataNumber-1 do
                  begin
                    if (CurrLine.XLine>=0) and (CurrLine.XLine<FLinesNumber) then
                      begin
                        XVal:=FLines[CurrLine.XLine].data[j];
                      end else
                      begin
                        xval:=j;
                      end;
                    YVal:=CurrLine.data[j];
                    X:=round(ParReg.Width*(XVal-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Y:=ParReg.height-round(ParReg.height*(YVal-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin));
                    if ptinrect(ParReg.clientrect,point(x,y)) then
                    case CurrLine.PointType of
                      iacblptNone :
                        begin
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                      iacblptCircle :
                        begin
                          ACanvas.pen.color:=CurrLine.PointColor;
                          ACanvas.brush.Style:=bsClear;
                          ACanvas.Ellipse(x-CurrLine.PointSize div 2,y-CurrLine.PointSize div 2,
                                          x+CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.brush.Style:=bsSolid;
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                      iacblptSquare :
                        begin
                          ACanvas.pen.color:=CurrLine.PointColor;
                          ACanvas.brush.Style:=bsClear;
                          ACanvas.Rectangle(x-CurrLine.PointSize div 2,y-CurrLine.PointSize div 2,
                                          x+CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.brush.Style:=bsSolid;
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                      iacblptTriangle :
                        begin
                          ACanvas.pen.color:=CurrLine.PointColor;
                          ACanvas.brush.Style:=bsClear;
                          ACanvas.MoveTo(x,y-CurrLine.PointSize div 2);
                          ACanvas.LineTo(x+CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.LineTo(x-CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.LineTo(x,y-CurrLine.PointSize div 2);
                          ACanvas.brush.Style:=bsSolid;
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                    end;
                  end;
              end else
              begin
                for j:=0 to FDataNumber-1 do
                  begin
                    if (CurrLine.XLine>=0) and (CurrLine.XLine<FLinesNumber) then
                      begin
                        XVal:=FLines[CurrLine.XLine].data[j];
                      end else
                      begin
                        xval:=j;
                      end;
                    YVal:=CurrLine.data[j];
                    Y:=ParReg.height-round(ParReg.height*(XVal-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    X:=round(ParReg.Width*(YVal-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin));

                    if ptinrect(ParReg.clientrect,point(x,y)) then
                    case CurrLine.PointType of
                      iacblptNone :
                        begin
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                      iacblptCircle :
                        begin
                          ACanvas.pen.color:=CurrLine.PointColor;
                          ACanvas.brush.Style:=bsClear;
                          ACanvas.Ellipse(x-CurrLine.PointSize div 2,y-CurrLine.PointSize div 2,
                                          x+CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.brush.Style:=bsSolid;
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                      iacblptSquare :
                        begin
                          ACanvas.pen.color:=CurrLine.PointColor;
                          ACanvas.brush.Style:=bsClear;
                          ACanvas.Rectangle(x-CurrLine.PointSize div 2,y-CurrLine.PointSize div 2,
                                          x+CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.brush.Style:=bsSolid;
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                      iacblptTriangle :
                        begin
                          ACanvas.pen.color:=CurrLine.PointColor;
                          ACanvas.brush.Style:=bsClear;
                          ACanvas.MoveTo(x,y-CurrLine.PointSize div 2);
                          ACanvas.LineTo(x+CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.LineTo(x-CurrLine.PointSize div 2,y+CurrLine.PointSize div 2);
                          ACanvas.LineTo(x,y-CurrLine.PointSize div 2);
                          ACanvas.brush.Style:=bsSolid;
                          Parreg.FPaintedPoints[i][j][0]:=x;
                          Parreg.FPaintedPoints[i][j][1]:=y;
                        end;
                    end;
                  end;

              end;
          end;
      end;

    end;
  //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++<----------------
  //Draw the Diapason's
  for i:=0 to FLinesNumber-1 do
    begin
      CurrLine:=FLines[i];
      case CurrLine.LineType of
        iacbltYData :
          begin
            if ParReg.XAxisType=iacbatHorizontal then
              begin
                for j:=0 to FDataNumber-1 do
                  begin
                    if (CurrLine.XLine>=0) and (CurrLine.XLine<FLinesNumber) then
                      begin
                        XVal:=FLines[CurrLine.XLine].data[j];
                      end else
                      begin
                        xval:=j;
                      end;
                    YVal:=CurrLine.data[j];
                    X:=round(ParReg.Width*(XVal-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Y:=ParReg.height-round(ParReg.height*(YVal-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin));
                    //Defining the diapason...
                    if (CurrLine.FXsubLine>=0) and (CurrLine.FXsubLine<FLinesNumber) then
                      begin
                        XvalDo:=FLines[CurrLine.FXsubLine].data[j];
                      end else
                      begin
                        XvalDo:=0;
                      end;
                    if (CurrLine.FXaddLine>=0) and (CurrLine.FXaddLine<FLinesNumber) then
                      begin
                        XvalPo:=FLines[CurrLine.FXaddLine].data[j];
                      end else
                      begin
                        XvalPo:=0;
                      end;
                    if (CurrLine.FYsubLine>=0) and (CurrLine.FYsubLine<FLinesNumber) then
                      begin
                        YvalDo:=FLines[CurrLine.FYsubLine].data[j];
                      end else
                      begin
                        YvalDo:=0;
                      end;
                    if (CurrLine.FYaddLine>=0) and (CurrLine.FYaddLine<FLinesNumber) then
                      begin
                        YvalPo:=FLines[CurrLine.FYaddLine].data[j];
                      end else
                      begin
                        YvalPo:=0;
                      end;
                    DipRect:=rect(
                      round(ParReg.Width*(XVal+Xvaldo-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin)),
                      ParReg.height-round(ParReg.height*(YVal+Yvaldo-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin)),
                      round(ParReg.Width*(XVal+XvalPo-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin)),
                      ParReg.height-round(ParReg.height*(YVal+YValPo-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin))
                      );


                    //DipRect

                    if ptinrect(ParReg.clientrect,point(x,y)) then
                    case CurrLine.DiapasonType of
                      iacbldtNone :
                        begin

                        end;
                      iacbldtCross :
                        begin
                          ACanvas.pen.color:=CurrLine.DiapasonColor;
                          if x<>Diprect.left then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(Diprect.left,y);
                              ACanvas.moveto(Diprect.left,y-2);
                              ACanvas.lineto(Diprect.left,y+2);
                            end;
                          if x<>Diprect.right then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(Diprect.right,y);
                              ACanvas.moveto(Diprect.right,y-2);
                              ACanvas.lineto(Diprect.right,y+2);
                            end;
                          if y<>Diprect.top then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(x,Diprect.top);
                              ACanvas.moveto(x-2,Diprect.top);
                              ACanvas.lineto(x+2,Diprect.top);
                            end;
                          if y<>Diprect.Bottom then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(x,Diprect.Bottom);
                              ACanvas.moveto(x-2,Diprect.Bottom);
                              ACanvas.lineto(x+2,Diprect.Bottom);
                            end;
                        end;
                      iacbldtRect :
                        begin
                          ACanvas.pen.color:=CurrLine.DiapasonColor;
                          ACanvas.brush.style:=bsClear;
                          aCanvas.Rectangle(Diprect.left,Diprect.top,Diprect.right,Diprect.bottom);
                          ACanvas.brush.style:=bsSolid;
                        end;
                    end;
                  end;
              end else
              begin
                for j:=0 to FDataNumber-1 do
                  begin
                    if (CurrLine.XLine>=0) and (CurrLine.XLine<FLinesNumber) then
                      begin
                        XVal:=FLines[CurrLine.XLine].data[j];
                      end else
                      begin
                        xval:=j;
                      end;
                    YVal:=CurrLine.data[j];
                    Y:=ParReg.height-round(ParReg.height*(XVal-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    X:=round(ParReg.Width*(YVal-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin));
//Defining the diapason...
                    if (CurrLine.FXsubLine>=0) and (CurrLine.FXsubLine<FLinesNumber) then
                      begin
                        XvalDo:=FLines[CurrLine.FXsubLine].data[j];
                      end else
                      begin
                        XvalDo:=0;
                      end;
                    if (CurrLine.FXaddLine>=0) and (CurrLine.FXaddLine<FLinesNumber) then
                      begin
                        XvalPo:=FLines[CurrLine.FXaddLine].data[j];
                      end else
                      begin
                        XvalPo:=0;
                      end;
                    if (CurrLine.FYsubLine>=0) and (CurrLine.FYsubLine<FLinesNumber) then
                      begin
                        YvalDo:=FLines[CurrLine.FYsubLine].data[j];
                      end else
                      begin
                        YvalDo:=0;
                      end;
                    if (CurrLine.FYaddLine>=0) and (CurrLine.FYaddLine<FLinesNumber) then
                      begin
                        YvalPo:=FLines[CurrLine.FYaddLine].data[j];
                      end else
                      begin
                        YvalPo:=0;
                      end;
                    DipRect:=rect(
                      round(ParReg.Width*(YVal+YvalDo-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin)),
                      ParReg.height-round(ParReg.height*(XVal+XValDo-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin)),
                      round(ParReg.Width*(YVal+YValPo-ParReg.YAxisBegin)/(ParReg.YAxisEnd-ParReg.YAxisBegin)),
                      ParReg.height-round(ParReg.height*(XVal+XValPo-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin))
                      );


                    //DipRect

                    if ptinrect(ParReg.clientrect,point(x,y)) then
                    case CurrLine.DiapasonType of
                      iacbldtNone :
                        begin

                        end;
                      iacbldtCross :
                        begin
                          ACanvas.pen.color:=CurrLine.DiapasonColor;
                          if x<>Diprect.left then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(Diprect.left,y);
                              ACanvas.moveto(Diprect.left,y-2);
                              ACanvas.lineto(Diprect.left,y+2);
                            end;
                          if x<>Diprect.right then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(Diprect.right,y);
                              ACanvas.moveto(Diprect.right,y-2);
                              ACanvas.lineto(Diprect.right,y+2);
                            end;
                          if y<>Diprect.top then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(x,Diprect.top);
                              ACanvas.moveto(x-2,Diprect.top);
                              ACanvas.lineto(x+2,Diprect.top);
                            end;
                          if y<>Diprect.Bottom then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(x,Diprect.Bottom);
                              ACanvas.moveto(x-2,Diprect.Bottom);
                              ACanvas.lineto(x+2,Diprect.Bottom);
                            end;
                        end;
                      iacbldtRect :
                        begin
                          ACanvas.pen.color:=CurrLine.DiapasonColor;
                          ACanvas.brush.style:=bsClear;
                          aCanvas.Rectangle(Diprect.left,Diprect.top,Diprect.right,Diprect.bottom);
                          ACanvas.brush.style:=bsSolid;
                        end;
                    end;
                  end;


              end;
          end;
        iacbltY2Data :
          begin
            if ParReg.XAxisType=iacbatHorizontal then
              begin
                for j:=0 to FDataNumber-1 do
                  begin
                    if (CurrLine.XLine>=0) and (CurrLine.XLine<FLinesNumber) then
                      begin
                        XVal:=FLines[CurrLine.XLine].data[j];
                      end else
                      begin
                        xval:=j;
                      end;
                    YVal:=CurrLine.data[j];
                    X:=round(ParReg.Width*(XVal-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    Y:=ParReg.height-round(ParReg.height*(YVal-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin));
                    //Defining the diapason...
                    if (CurrLine.FXsubLine>=0) and (CurrLine.FXsubLine<FLinesNumber) then
                      begin
                        XvalDo:=FLines[CurrLine.FXsubLine].data[j];
                      end else
                      begin
                        XvalDo:=0;
                      end;
                    if (CurrLine.FXaddLine>=0) and (CurrLine.FXaddLine<FLinesNumber) then
                      begin
                        XvalPo:=FLines[CurrLine.FXaddLine].data[j];
                      end else
                      begin
                        XvalPo:=0;
                      end;
                    if (CurrLine.FYsubLine>=0) and (CurrLine.FYsubLine<FLinesNumber) then
                      begin
                        YvalDo:=FLines[CurrLine.FYsubLine].data[j];
                      end else
                      begin
                        YvalDo:=0;
                      end;
                    if (CurrLine.FYaddLine>=0) and (CurrLine.FYaddLine<FLinesNumber) then
                      begin
                        YvalPo:=FLines[CurrLine.FYaddLine].data[j];
                      end else
                      begin
                        YvalPo:=0;
                      end;
                    DipRect:=rect(
                      round(ParReg.Width*(XVal+Xvaldo-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin)),
                      ParReg.height-round(ParReg.height*(YVal+Yvaldo-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin)),
                      round(ParReg.Width*(XVal+XvalPo-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin)),
                      ParReg.height-round(ParReg.height*(YVal+YValPo-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin))
                      );


                    //DipRect

                    if ptinrect(ParReg.clientrect,point(x,y)) then
                    case CurrLine.DiapasonType of
                      iacbldtNone :
                        begin

                        end;
                      iacbldtCross :
                        begin
                          ACanvas.pen.color:=CurrLine.DiapasonColor;
                          if x<>Diprect.left then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(Diprect.left,y);
                              ACanvas.moveto(Diprect.left,y-2);
                              ACanvas.lineto(Diprect.left,y+2);
                            end;
                          if x<>Diprect.right then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(Diprect.right,y);
                              ACanvas.moveto(Diprect.right,y-2);
                              ACanvas.lineto(Diprect.right,y+2);
                            end;
                          if y<>Diprect.top then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(x,Diprect.top);
                              ACanvas.moveto(x-2,Diprect.top);
                              ACanvas.lineto(x+2,Diprect.top);
                            end;
                          if y<>Diprect.Bottom then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(x,Diprect.Bottom);
                              ACanvas.moveto(x-2,Diprect.Bottom);
                              ACanvas.lineto(x+2,Diprect.Bottom);
                            end;
                        end;
                      iacbldtRect :
                        begin
                          ACanvas.pen.color:=CurrLine.DiapasonColor;
                          ACanvas.brush.style:=bsClear;
                          aCanvas.Rectangle(Diprect.left,Diprect.top,Diprect.right,Diprect.bottom);
                          ACanvas.brush.style:=bsSolid;
                        end;
                    end;
                  end;
              end else
              begin
                for j:=0 to FDataNumber-1 do
                  begin
                    if (CurrLine.XLine>=0) and (CurrLine.XLine<FLinesNumber) then
                      begin
                        XVal:=FLines[CurrLine.XLine].data[j];
                      end else
                      begin
                        xval:=j;
                      end;
                    YVal:=CurrLine.data[j];
                    Y:=ParReg.height-round(ParReg.height*(XVal-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin));
                    X:=round(ParReg.Width*(YVal-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin));
//Defining the diapason...
                    if (CurrLine.FXsubLine>=0) and (CurrLine.FXsubLine<FLinesNumber) then
                      begin
                        XvalDo:=FLines[CurrLine.FXsubLine].data[j];
                      end else
                      begin
                        XvalDo:=0;
                      end;
                    if (CurrLine.FXaddLine>=0) and (CurrLine.FXaddLine<FLinesNumber) then
                      begin
                        XvalPo:=FLines[CurrLine.FXaddLine].data[j];
                      end else
                      begin
                        XvalPo:=0;
                      end;
                    if (CurrLine.FYsubLine>=0) and (CurrLine.FYsubLine<FLinesNumber) then
                      begin
                        YvalDo:=FLines[CurrLine.FYsubLine].data[j];
                      end else
                      begin
                        YvalDo:=0;
                      end;
                    if (CurrLine.FYaddLine>=0) and (CurrLine.FYaddLine<FLinesNumber) then
                      begin
                        YvalPo:=FLines[CurrLine.FYaddLine].data[j];
                      end else
                      begin
                        YvalPo:=0;
                      end;
                    DipRect:=rect(
                      round(ParReg.Width*(YVal+YvalDo-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin)),
                      ParReg.height-round(ParReg.height*(XVal+XValDo-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin)),
                      round(ParReg.Width*(YVal+YValPo-ParReg.YAxis2Begin)/(ParReg.YAxis2End-ParReg.YAxis2Begin)),
                      ParReg.height-round(ParReg.height*(XVal+XValPo-ParReg.XAxisBegin)/(ParReg.XAxisEnd-ParReg.XAxisBegin))
                      );


                    //DipRect

                    if ptinrect(ParReg.clientrect,point(x,y)) then
                    case CurrLine.DiapasonType of
                      iacbldtNone :
                        begin

                        end;
                      iacbldtCross :
                        begin
                          ACanvas.pen.color:=CurrLine.DiapasonColor;
                          if x<>Diprect.left then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(Diprect.left,y);
                              ACanvas.moveto(Diprect.left,y-2);
                              ACanvas.lineto(Diprect.left,y+2);
                            end;
                          if x<>Diprect.right then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(Diprect.right,y);
                              ACanvas.moveto(Diprect.right,y-2);
                              ACanvas.lineto(Diprect.right,y+2);
                            end;
                          if y<>Diprect.top then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(x,Diprect.top);
                              ACanvas.moveto(x-2,Diprect.top);
                              ACanvas.lineto(x+2,Diprect.top);
                            end;
                          if y<>Diprect.Bottom then
                            begin
                              ACanvas.moveto(x,y);
                              ACanvas.lineto(x,Diprect.Bottom);
                              ACanvas.moveto(x-2,Diprect.Bottom);
                              ACanvas.lineto(x+2,Diprect.Bottom);
                            end;
                        end;
                      iacbldtRect :
                        begin
                          ACanvas.pen.color:=CurrLine.DiapasonColor;
                          ACanvas.brush.style:=bsClear;
                          aCanvas.Rectangle(Diprect.left,Diprect.top,Diprect.right,Diprect.bottom);
                          ACanvas.brush.style:=bsSolid;
                        end;
                    end;
                  end;

              end;
          end;
      end;

    end;
end;

procedure IAChartBaseLineArray.DrawSpline(ACanvas: TCanvas; x1, x2, x3, x4,
  y1, y2, y3, y4: integer);
var   a1,a2,b1,b2,c1,c2,d1,d2,t : double;
begin
  a1:=x2;
  b1:=(x3-x1)/2;
  d1:=(x4-3*x3+3*x2-x1)/2;
  c1:=(-x4+4*x3-5*x2+2*x1)/2;

  a2:=y2;
  b2:=(y3-y1)/2;
  d2:=(y4-3*y3+3*y2-y1)/2;
  c2:=(-y4+4*y3-5*y2+2*y1)/2;

  {
    a1:=x2;
  b1:=x2-x1;
  d1:=-x3+2*x2-x1;
  c1:=2*x3-4*x2+2*x1;

  a2:=y2;
  b2:=y2-y1;
  d2:=-y3+2*y2-y1;
  c2:=2*y3-4*y2+2*y1; }

  t:=0;ACanvas.moveto(x2,y2);
  while T<=1.005 do
    begin
      ACanvas.lineto(round(a1+b1*t+c1*t*t+d1*t*t*t),round(a2+b2*t+c2*t*t+d2*t*t*t));
      t:=t+0.01;
    end;
end;

procedure IAChartBaseLineArray.SetCommonInfo(Value: string);
begin
  if FCommonInfo<>value then
    begin
      FCommonInfo := Value;
      if (FOwner is IAChartBaseLinesClass) and assigned((FOwner as IAChartBaseLinesClass).parent) and
        ((FOwner as IAChartBaseLinesClass).parent.handleALlocated) then
        begin
          postMessage((FOwner as IAChartBaseLinesClass).parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);
        end;
    end;
end;

procedure IAChartBaseLineArray.SetDataNumber(Value: Integer);
var i : integer;

begin
  if (FDataNumber<>Value) and (Value>=0) then
    begin
      for i:=0 to FLinesNumber-1 do
        begin
          FLines[i].free;
        end;
      setlength(FLines,0);
      FDataNumber := Value;
      if FLinesNumber>=0 then
        begin
          setlength(FLines,FLinesNumber);
          for i:=low(FLines) to high(FLines) do
            begin
              FLines[i]:=IAChartBaseLine.Create(self.FOwner);
              FLines[i].Number:=FDataNumber;
            end;
        end;
      if (FOwner is IAChartBaseLinesClass) and assigned((FOwner as IAChartBaseLinesClass).parent) and
        ((FOwner as IAChartBaseLinesClass).parent.handleALlocated) then
        begin
          postMessage((FOwner as IAChartBaseLinesClass).parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);
        end;
    end;
end;

procedure IAChartBaseLineArray.SetLines(Value: IAChartDataArrayArr);
var  i : integer;
begin
  if (Value<>nil) and (length(Value)=FLinesNumber) then
    begin
      for i:=0 to FLinesNumber-1 do
        begin
          FLines[i+low(FLines)].assign(Value[i+low(Value)]);
        end;
      if (FOwner is IAChartBaseLinesClass) and assigned((FOwner as IAChartBaseLinesClass).parent) and
        ((FOwner as IAChartBaseLinesClass).parent.handleALlocated) then
        begin
          postMessage((FOwner as IAChartBaseLinesClass).parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);
        end;
    end;
end;

procedure IAChartBaseLineArray.SetLinesNumber(Value: Integer);
var i : integer;

begin
  if (FLinesNumber<>Value) and (Value>=0) then
    begin
      for i:=0 to FLinesNumber-1 do
        begin
          FLines[i].free;
        end;
      setlength(FLines,0);
      FLinesNumber := Value;
      if FLinesNumber>=0 then
        begin
          setlength(FLines,FLinesNumber);
          for i:=low(FLines) to high(FLines) do
            begin
              FLines[i]:=IAChartBaseLine.Create(self.FOwner);
              FLines[i].Number:=FDataNumber;
              FLines[i].infostring:='Line - '+inttostr(i);
            end;
        end;
      if (FOwner is IAChartBaseLinesClass) and assigned((FOwner as IAChartBaseLinesClass).parent) and
        ((FOwner as IAChartBaseLinesClass).parent.handleALlocated) then
        begin
          postMessage((FOwner as IAChartBaseLinesClass).parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);
        end;
    end;
end;

end.
