unit IAChartBaseTextEditUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TIAChartBaseTextEditWindow = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    FontDialog1: TFontDialog;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Label1: TLabel;
    ColorDialog1: TColorDialog;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Memo1Exit(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private declarations }
    AStart,ALength : integer;
  public
    FCurrControl : TControl;
    { Public declarations }
    procedure UpdateExample;
    procedure BackUpdate;
  end;

var
  IAChartBaseTextEditWindow: TIAChartBaseTextEditWindow;

implementation
uses IAChartBaseTextUnit;
var CurrExample : IAChartBaseTextClass;

{$R *.DFM}

procedure TIAChartBaseTextEditWindow.FormCreate(Sender: TObject);
begin
  FCurrControl:=nil;
  CurrExample:=IAChartBaseTextClass.Create(self);
  CurrExample.parent:=panel1;
  CurrExample.AutoEditable:=False;
  CurrExample.Visible:=True;
  CurrExample.Text:='Example';
end;

procedure TIAChartBaseTextEditWindow.FormDestroy(Sender: TObject);
begin
  CurrExample.parent:=nil;
  CurrExample.free;
end;

procedure TIAChartBaseTextEditWindow.FormActivate(Sender: TObject);
begin
  if assigned(FCurrControl) then
    begin
      Memo1.text:=(FCurrControl as IAChartBaseTextClass).StringsArray.Text;
      UpdateExample;
      Edit1.text:=inttostr(CurrExample.InnerGap);
      Edit2.text:=inttostr(CurrExample.OuterGap);
      case CurrExample.BorderStyle of
        iacbbsNone : Combobox1.Text:=Combobox1.items[0];
        iacbbsSimple :Combobox1.Text:=Combobox1.items[1];
        iacbbsRising : Combobox1.Text:=Combobox1.items[2];
        iacbbsPressed : Combobox1.Text:=Combobox1.items[3];
        iacbbsUp :  Combobox1.Text:=Combobox1.items[4];
        iacbbsDown : Combobox1.Text:=Combobox1.items[5];
      end;
    end;
end;

procedure TIAChartBaseTextEditWindow.UpdateExample;
begin
  if assigned(FCurrControl) and (FCurrControl is IAChartBaseTextClass) then
    begin
      CurrExample.Text:=(FCurrControl as IAChartBaseTextClass).Text;
      CurrExample.Font:=(FCurrControl as IAChartBaseTextClass).Font;
      CurrExample.Color:=(FCurrControl as IAChartBaseTextClass).Color;
      CurrExample.TextOrientation:=(FCurrControl as IAChartBaseTextClass).TextOrientation;
      CurrExample.InnerGap:=(FCurrControl as IAChartBaseTextClass).InnerGap;
      CurrExample.OuterGap:=(FCurrControl as IAChartBaseTextClass).OuterGap;
      CurrExample.Borderstyle:=(FCurrControl as IAChartBaseTextClass).Borderstyle;
      CurrExample.CurrImageList:=(FCurrControl as IAChartBaseTextClass).CurrImageList;
      CurrExample.Transparence:=(FCurrControl as IAChartBaseTextClass).Transparence;
    end;
end;

procedure TIAChartBaseTextEditWindow.Memo1Change(Sender: TObject);
begin
  CurrExample.Text:=Memo1.lines.text;
end;

procedure TIAChartBaseTextEditWindow.Button1Click(Sender: TObject);
var s : string;
begin
  s:=copy(memo1.Lines.Text,0,aStart)+'<up>'+copy(memo1.Lines.Text,aStart+1,aLength)+'</up>'+
  copy(memo1.Lines.Text,aStart+aLength+1,length(memo1.Lines.Text)-aStart-aLength);
  memo1.Lines.Text:=s;
end;

procedure TIAChartBaseTextEditWindow.Button2Click(Sender: TObject);
var s : string;
begin
  s:=copy(memo1.Lines.Text,0,aStart)+'<down>'+copy(memo1.Lines.Text,aStart+1,aLength)+'</down>'+
  copy(memo1.Lines.Text,aStart+aLength+1,length(memo1.Lines.Text)-aStart-aLength);
  memo1.Lines.Text:=s;
end;

procedure TIAChartBaseTextEditWindow.Button6Click(Sender: TObject);
var s : string;
begin
  s:=copy(memo1.Lines.Text,0,aStart)+'<size>'+'8</size>'+copy(memo1.Lines.Text,aStart+1,aLength)+
  copy(memo1.Lines.Text,aStart+aLength+1,length(memo1.Lines.Text)-aStart-aLength);
  memo1.Lines.Text:=s;
end;

procedure TIAChartBaseTextEditWindow.Button7Click(Sender: TObject);
var s : string;
begin
  s:=copy(memo1.Lines.Text,0,aStart)+'<inline>'+'8</inline>'+copy(memo1.Lines.Text,aStart+1,aLength)+
  copy(memo1.Lines.Text,aStart+aLength+1,length(memo1.Lines.Text)-aStart-aLength);
  memo1.Lines.Text:=s;
end;

procedure TIAChartBaseTextEditWindow.Button3Click(Sender: TObject);
var s : string;
begin
  s:=copy(memo1.Lines.Text,0,aStart)+'<B>'+copy(memo1.Lines.Text,aStart+1,aLength)+'</B>'+
  copy(memo1.Lines.Text,aStart+aLength+1,length(memo1.Lines.Text)-aStart-aLength);
  memo1.Lines.Text:=s;
end;

procedure TIAChartBaseTextEditWindow.Button4Click(Sender: TObject);
var s : string;
begin
  s:=copy(memo1.Lines.Text,0,aStart)+'<I>'+copy(memo1.Lines.Text,aStart+1,aLength)+'</I>'+
  copy(memo1.Lines.Text,aStart+aLength+1,length(memo1.Lines.Text)-aStart-aLength);
  memo1.Lines.Text:=s;
end;

procedure TIAChartBaseTextEditWindow.Button5Click(Sender: TObject);
var s : string;
begin
  s:=copy(memo1.Lines.Text,0,aStart)+'<U>'+copy(memo1.Lines.Text,aStart+1,aLength)+'</U>'+
  copy(memo1.Lines.Text,aStart+aLength+1,length(memo1.Lines.Text)-aStart-aLength);
  memo1.Lines.Text:=s;
end;

procedure TIAChartBaseTextEditWindow.Memo1Exit(Sender: TObject);
begin
AStart:=memo1.SelStart;
Alength:=memo1.SelLength;
end;

procedure TIAChartBaseTextEditWindow.Button10Click(Sender: TObject);
begin
FontDialog1.font:=CurrExample.font;
 if FontDialog1.Execute then
   begin
     CurrExample.font:=FontDialog1.font;
   end;
end;

procedure TIAChartBaseTextEditWindow.BackUpdate;
begin
  if assigned(FCurrControl) and (FCurrControl is IAChartBaseTextClass) then
    begin
      (FCurrControl as IAChartBaseTextClass).Text:=CurrExample.Text;
      (FCurrControl as IAChartBaseTextClass).Font:=CurrExample.Font;
      (FCurrControl as IAChartBaseTextClass).Color:=CurrExample.Color;
      (FCurrControl as IAChartBaseTextClass).TextOrientation:=CurrExample.TextOrientation;
      (FCurrControl as IAChartBaseTextClass).InnerGap:=CurrExample.InnerGap;
      (FCurrControl as IAChartBaseTextClass).OuterGap:=CurrExample.OuterGap;
      (FCurrControl as IAChartBaseTextClass).Borderstyle:=CurrExample.Borderstyle;
      (FCurrControl as IAChartBaseTextClass).Transparence:=CurrExample.Transparence;
    end;
end;

procedure TIAChartBaseTextEditWindow.Button14Click(Sender: TObject);
begin
  CurrExample.TextOrientation:=iacbto_0_Degrees;
end;

procedure TIAChartBaseTextEditWindow.Button12Click(Sender: TObject);
begin
  CurrExample.TextOrientation:=iacbto_90_Degrees;
end;

procedure TIAChartBaseTextEditWindow.Button15Click(Sender: TObject);
begin
  CurrExample.TextOrientation:=iacbto_180_Degrees;
end;

procedure TIAChartBaseTextEditWindow.Button13Click(Sender: TObject);
begin
  CurrExample.TextOrientation:=iacbto_270_Degrees;
end;

procedure TIAChartBaseTextEditWindow.Button11Click(Sender: TObject);
begin
ColorDialog1.Color:=CurrExample.font.color;
if  ColorDialog1.execute then
  begin
    CurrExample.font.color:=ColorDialog1.Color;
  end;
end;

procedure TIAChartBaseTextEditWindow.Button16Click(Sender: TObject);
begin
ColorDialog1.Color:=CurrExample.color;
if  ColorDialog1.execute then
  begin
    CurrExample.color:=ColorDialog1.Color;
  end;
end;

procedure TIAChartBaseTextEditWindow.Button17Click(Sender: TObject);
begin
  CurrExample.Transparence:=not CurrExample.Transparence;
end;

procedure TIAChartBaseTextEditWindow.Edit1Change(Sender: TObject);
begin
  (sender as TEdit).text:=inttostr(strtointdef((sender as TEdit).text,0));
  if (sender as TEdit)= Edit1 then
    begin
      CurrExample.InnerGap:=strtointdef((sender as TEdit).text,0);
    end else
    begin
      if (sender as TEdit)= Edit2 then
        begin
          CurrExample.OuterGap:=strtointdef((sender as TEdit).text,0);
        end else
        begin

        end;
    end;
end;

procedure TIAChartBaseTextEditWindow.ComboBox1Change(Sender: TObject);
begin
  if Combobox1.Text=Combobox1.Items[0] then
    begin
      CurrExample.BorderStyle:=iacbbsNone;
    end else
    begin
      if Combobox1.Text=Combobox1.Items[1] then
        begin
          CurrExample.BorderStyle:=iacbbsSimple;
        end else
        begin
          if Combobox1.Text=Combobox1.Items[2] then
            begin
              CurrExample.BorderStyle:=iacbbsRising;
            end else
            begin
              if Combobox1.Text=Combobox1.Items[3] then
                begin
                  CurrExample.BorderStyle:=iacbbsPressed;
                end else
                begin
                  if Combobox1.Text=Combobox1.Items[4] then
                    begin
                      CurrExample.BorderStyle:=iacbbsUp;
                    end else
                    begin
                      if Combobox1.Text=Combobox1.Items[5] then
                        begin
                          CurrExample.BorderStyle:=iacbbsDown;
                        end else
                        begin

                        end;
                    end;
                end;
            end;
        end;
    end;
end;

end.
