unit IAUniChart2D;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,IAChartBaseTextUnit,
  DsgnIntf,IAChartBaseAxisUnit,math,IAChartBaseMovingUnit,IAChartBaseLinesUnit,clipbrd,
  IAUniChart2DEditorUnit;
const
  CM_DRAWINNER = CM_BASE+101;
  CM_RESIZEINNER = CM_BASE+102;
type
  TIAChartBevel = (iacbUp,iacbDown,iacbUpFlat,iacbDownFlat,iacbNone);
  TIAChartResizeReaction = (iacrrNone,iacrrStandart);
  TIAChartInnerPanel  = Class(TCustomControl)
  private

    procedure WMSIZE(var Message : TMessage);message WM_SIZE;
    procedure CMNEWFONT(var Message : TMessage);message CM_NEWFONT;
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure CMAXISSIZED(var Message: TMessage); message CM_AXISSIZED;
    procedure CMUSERMURESIZED(var Message: TMessage); message CM_USERMURESIZED;
    procedure CMAXISMOVED(var Message: TMessage); message CM_AXISMOVED;
    procedure CMORIENTATIONCHANGED(var Message: TMessage); message CM_ORIENTATIONCHANGED;
    procedure CMAXISCLICKED(var Message: TWMLButtonDown); message  CM_AXISCLICKED;
    procedure CMBASELINESMOVED(var Message: TMessage); message CM_BASELINESMOVED;
    procedure CMBASELINESSIZED(var Message: TMessage); message CM_BASELINESSIZED;
    procedure CMAXISRECALIBRATED(var Message: TMessage); message CM_AXISRECALIBRATED;
    procedure CMUSERWANTSRESIZE(var Message: TMessage); message CM_USERWANTSRESIZE;
    procedure CMUSERCHANGELINESREPRESENTATION(var Message: TMessage); message CM_USERCHANGELINESREPRESENTATION;
    procedure CMUSERDBLCLICK(var Message: TMessage); message  CM_USERDBLCLICK;
    procedure CMAXISDBLCLICKED(var Message: TMessage); message CM_AXISDBLCLICKED;
    {  CM_BASELINESMOVED = CM_BASE+150;
  CM_BASELINESSIZED = CM_BASE+151;}
    function FontsIsEqual(F1,F2 : TFont): Boolean;
  protected
    procedure Paint; override;

  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
  end;
  TIAUniChart2D = class(TCustomControl)
  private
    { Private declarations }
    isFirst : Boolean;
    isCreated : boolean;
    dwidth,dheight,OldWidth,OldHeight : integer;
    FXCaption,FYCaption : IAChartBaseTextClassData;
    FXAxis,FYAxis :IAChartBaseAxisClassData;
    FGapInner: byte;
    FGapInOut: byte;
    FBevelOuterWidth: byte;
    FGapOuter: byte;
    FBevelInnerWidth: byte;
    FBevelOuter: TIAChartBevel;
    FBevelInner: TIAChartBevel;
    FInnerPanel : TIAChartInnerPanel;
    FBevelColor: TColor;
    FResizeReaction: TIAChartResizeReaction;
    FLinesField: IAChartBaseTextClassData;
    FMainCaption: IAChartBaseTextClassData;
    FUserTextField: IAChartBaseTextClassData;
    FYAxis2: IAChartBaseAxisClassData;
    FYCaption2: IAChartBaseTextClassData;
    FMainField: IAChartBaseLinesClassData;
    FBackLineDrawBitmap: TBitmap;
    FLineImageList : TImageList;
    FbackLineBitmapTransparent: Boolean;
    FOnYAxisDblClick: TNotifyEvent;
    FOnYAxis2DblClick: TNotifyEvent;
    FOnLinesInfoFieldDblClick: TNotifyEvent;
    FOnYAxisCaptionDblClick: TNotifyEvent;
    FOnUserInfoFieldDblClick: TNotifyEvent;
    FOnXAxisCaptionDblClick: TNotifyEvent;
    FOnMainFieldDblClick: TNotifyEvent;
    FOnXAxisDblClick: TNotifyEvent;
    FOnMainCaptionDblClick: TNotifyEvent;
    FOnYAxis2CaptionDblClick: TNotifyEvent;

    procedure CMDRAWINNER(var Message : TMessage);message CM_DRAWINNER;
    procedure CMRESIZEINNER(var Message : TMessage);message CM_RESIZEINNER;
    procedure WMSIZE(var Message : TMessage);message WM_Size;
    procedure CMAXISSIZED(var Message : TMessage);message CM_AXISSIZED;
    procedure CMAXISMOVED(var Message : TMessage);message CM_AXISMOVED;
    procedure CMBASELINESMOVED(var Message: TMessage); message CM_BASELINESMOVED;
    procedure CMBASELINESSIZED(var Message: TMessage); message CM_BASELINESSIZED;
    procedure CMAXISRECALIBRATED(var Message: TMessage); message CM_AXISRECALIBRATED;
    procedure CMUSERWANTSRESIZE(var Message: TMessage); message CM_USERWANTSRESIZE;
    procedure CMUSERCHANGELINESREPRESENTATION(var Message: TMessage); message CM_USERCHANGELINESREPRESENTATION;
    procedure CMUSERDBLCLICK(var Message: TMessage); message  CM_USERDBLCLICK;
    procedure CMAXISDBLCLICKED(var Message: TMessage); message CM_AXISDBLCLICKED;
    procedure SetXAxis(Value: IAChartBaseAxisClassData);
    procedure SetYAxis(Value: IAChartBaseAxisClassData);
    procedure SetXCaption(Value: IAChartBaseTextClassData);
    procedure SetYCaption(Value: IAChartBaseTextClassData);
    function GetColor: TColor;
    procedure SetBevelInner(Value: TIAChartBevel);
    procedure SetBevelInnerWidth(Value: byte);
    procedure SetBevelOuter(Value: TIAChartBevel);
    procedure SetBevelOuterWidth(Value: byte);
    procedure SetColor(Value: TColor);
    procedure SetGapInner(Value: byte);
    procedure SetGapInOut(Value: byte);
    procedure SetGapOuter(Value: byte);
    procedure SetInnerSizes;
    procedure SetBevelColor(Value: TColor);
    function GetDColor(Value: Tcolor): Tcolor;
    function GetLColor(Value: Tcolor): Tcolor;
    procedure SetResizeReaction(Value: TIAChartResizeReaction);
    procedure SetLinesField(Value: IAChartBaseTextClassData);
    procedure SetMainCaption(Value: IAChartBaseTextClassData);
    procedure SetUserTextField(Value: IAChartBaseTextClassData);
    procedure SetYAxis2(Value: IAChartBaseAxisClassData);
    procedure SetYCaption2(Value: IAChartBaseTextClassData);
    procedure SetMainField(Value: IAChartBaseLinesClassData);
    procedure MainByAxis;
    procedure AxisByMain;
    procedure DefMainDiapason(AMain : IAChartBaseLinesClass);
    procedure SetBackLineDrawBitmap(Value: TBitmap);
    procedure SetbackLineBitmapTransparent(Value: Boolean);
    function GetPointedBitmap(ABitmap : TBitmap;N : integer): TBitmap;
    procedure SetOnLinesInfoFieldDblClick(Value: TNotifyEvent);
    procedure SetOnMainCaptionDblClick(Value: TNotifyEvent);
    procedure SetOnMainFieldDblClick(Value: TNotifyEvent);
    procedure SetOnUserInfoFieldDblClick(Value: TNotifyEvent);
    procedure SetOnXAxisCaptionDblClick(Value: TNotifyEvent);
    procedure SetOnXAxisDblClick(Value: TNotifyEvent);
    procedure SetOnYAxis2CaptionDblClick(Value: TNotifyEvent);
    procedure SetOnYAxis2DblClick(Value: TNotifyEvent);
    procedure SetOnYAxisCaptionDblClick(Value: TNotifyEvent);
    procedure SetOnYAxisDblClick(Value: TNotifyEvent);
  protected
    procedure Paint; override;
    procedure CreateHandle;override;
    procedure Loaded;override;

  public
    procedure Assign(Source: TPersistent); override;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure AutoRecalibrate(AReservePercent : double = 10);
    procedure Reasseble;
    function GetChartBitmap: TBitmap;
    procedure SaveAsBitmapAT(AFileName : String);
    procedure CopyChartToClipBoard;
    function GetInnerWidth: integer;
    function GetInnerHeight : Integer;
  published
    { Published declarations }
    property Visible;
    property Align;
    property Anchors;
    property Constraints;
    property Enabled;
    property ShowHint;

    property MainField : IAChartBaseLinesClassData read FMainField write SetMainField;
    property BevelInner : TIAChartBevel read FBevelInner write SetBevelInner default iacbDown;
    property BevelOuter : TIAChartBevel read FBevelOuter write SetBevelOuter default iacbUp;
    property Color : TColor read GetColor write SetColor default clGray;
    property BevelInnerWidth : byte read FBevelInnerWidth write SetBevelInnerWidth default 2;
    property BevelOuterWidth : byte read FBevelOuterWidth write SetBevelOuterWidth default 2;
    property GapInner : byte read FGapInner write SetGapInner default 2;
    property GapOuter : byte read FGapOuter write SetGapOuter default 2;
    property GapInOut : byte read FGapInOut write SetGapInOut default 0;
    property XCaption : IAChartBaseTextClassData read FXCaption write SetXCaption;
    property YCaption : IAChartBaseTextClassData read FYCaption write SetYCaption;
    property YCaption2 : IAChartBaseTextClassData read FYCaption2 write SetYCaption2;
    property XAxis : IAChartBaseAxisClassData read FXAxis write SetXAxis;
    property YAxis : IAChartBaseAxisClassData read FYAxis write SetYAxis;
    property YAxis2 : IAChartBaseAxisClassData read FYAxis2 write SetYAxis2;
    property BevelColor : TColor read FBevelColor write SetBevelColor default clSilver;
    property ResizeReaction :TIAChartResizeReaction read FResizeReaction write SetResizeReaction default iacrrStandart;
    property MainCaption   : IAChartBaseTextClassData read FMainCaption write SetMainCaption;
    property UserTextField : IAChartBaseTextClassData read FUserTextField write SetUserTextField;
    property LinesField    : IAChartBaseTextClassData read FLinesField write SetLinesField;
    property BackLineDrawBitmap : TBitmap read FBackLineDrawBitmap write SetBackLineDrawBitmap;
    property BackLineBitmapTransparent : Boolean read FBackLineBitmapTransparent write SetBackLineBitmapTransparent;

    property OnXAxisDblClick : TNotifyEvent read FOnXAxisDblClick write SetOnXAxisDblClick;
    property OnYAxisDblClick : TNotifyEvent read FOnYAxisDblClick write SetOnYAxisDblClick;
    property OnYAxis2DblClick : TNotifyEvent read FOnYAxis2DblClick write SetOnYAxis2DblClick;
    property OnXAxisCaptionDblClick : TNotifyEvent read FOnXAxisCaptionDblClick write SetOnXAxisCaptionDblClick;
    property OnYAxisCaptionDblClick : TNotifyEvent read FOnYAxisCaptionDblClick write SetOnYAxisCaptionDblClick;
    property OnYAxis2CaptionDblClick : TNotifyEvent read FOnYAxis2CaptionDblClick write SetOnYAxis2CaptionDblClick;
    property OnMainCaptionDblClick : TNotifyEvent read FOnMainCaptionDblClick write SetOnMainCaptionDblClick;
    property OnLinesInfoFieldDblClick : TNotifyEvent read FOnLinesInfoFieldDblClick write SetOnLinesInfoFieldDblClick;
    property OnUserInfoFieldDblClick : TNotifyEvent read FOnUserInfoFieldDblClick write SetOnUserInfoFieldDblClick;
    property OnMainFieldDblClick : TNotifyEvent read FOnMainFieldDblClick write SetOnMainFieldDblClick;
    property OnResize;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('TIA', [TIAUniChart2D]);
  RegisterPropertyEditor(Typeinfo(IAChartBaseTextClassData),TIAUniChart2D,'XCaption',TClassProperty);
  RegisterPropertyEditor(Typeinfo(IAChartBaseTextClassData),TIAUniChart2D,'YCaption',TClassProperty);
  RegisterPropertyEditor(Typeinfo(IAChartBaseTextClassData),TIAUniChart2D,'YCaption2',TClassProperty);
  RegisterPropertyEditor(Typeinfo(IAChartBaseTextClassData),TIAUniChart2D,'MainCaption',TClassProperty);
  RegisterPropertyEditor(Typeinfo(IAChartBaseTextClassData),TIAUniChart2D,'UserTextField',TClassProperty);
  RegisterPropertyEditor(Typeinfo(IAChartBaseTextClassData),TIAUniChart2D,'LinesField',TClassProperty);
  RegisterPropertyEditor(Typeinfo(IAChartBaseAxisClassData),TIAUniChart2D,'XAxis',TClassProperty);
  RegisterPropertyEditor(Typeinfo(IAChartBaseAxisClassData),TIAUniChart2D,'YAxis',TClassProperty);
  RegisterPropertyEditor(Typeinfo(IAChartBaseAxisClassData),TIAUniChart2D,'YAxis2',TClassProperty);
  RegisterPropertyEditor(Typeinfo(IAChartBaseLinesClassData),TIAUniChart2D,'MainField',TClassProperty);
  RegisterComponentEditor(TIAUniChart2D,TIAUniChart2DEditor);
end;

{ TIAUniChart2D }

procedure TIAUniChart2D.CMDRAWINNER(var Message: TMessage);
begin
//here we draw the inner
  FInnerPanel.Canvas.Brush.color:=Color;
  FInnerPanel.Canvas.FillRect(rect(0,0,FInnerPanel.Width,FInnerPanel.Height));
end;

constructor TIAUniChart2D.Create(AOwner: TComponent);
begin
  inherited create(AOwner);
  isFirst:=true;
  FOnYAxisDblClick:=nil;
  FOnYAxis2DblClick:=nil;
  FOnLinesInfoFieldDblClick:=nil;
  FOnYAxisCaptionDblClick:=nil;
  FOnUserInfoFieldDblClick:=nil;
  FOnXAxisCaptionDblClick:=nil;
  FOnMainFieldDblClick:=nil;
  FOnXAxisDblClick:=nil;
  FOnMainCaptionDblClick:=nil;
  FOnYAxis2CaptionDblClick:=nil;



  isCreated:=false;
  width:=200;
  height:=200;
  self.ControlStyle:=self.ControlStyle+[csOpaque];
  FGapInner:=2;
  FGapInOut:=0;
  FBevelOuterWidth:=2;
  FGapOuter:=2;
  FBevelInnerWidth:=2;
  FBevelOuter := iacbUp;
  FBevelInner := iacbDown;
  inherited Color:=$00A0A0A0;
  FBevelColor:=clSilver;
  FResizeReaction:=iacrrStandart;
  FBackLineDrawBitmap:=TBitmap.create;
  FBackLineDrawBitmap.Width:=0;
  FBackLineDrawBitmap.height:=0;
  FBackLineDrawBitmap.PixelFormat:=pf24Bit;
  FLineImageList:=TImageList.Create(self);

  FInnerPanel := TIAChartInnerPanel.Create(self);
  FInnerPanel.Parent:=self;
  dwidth:=0;
  DHeight:=0;
  SetInnerSizes;

  FMainField:=IAChartBaseLinesClassData.Create(FInnerPanel);



  FXAxis:=IAChartBaseAxisClassData.Create(FInnerPanel);
  FYAxis:=IAChartBaseAxisClassData.Create(FInnerPanel);
  FYAxis2:=IAChartBaseAxisClassData.Create(FInnerPanel);
  FXCaption := IAChartBaseTextClassData.create(FInnerPanel);
  FYCaption := IAChartBaseTextClassData.create(FInnerPanel);
  FYCaption2 := IAChartBaseTextClassData.create(FInnerPanel);
  FLinesField   := IAChartBaseTextClassData.create(FInnerPanel);
  FMainCaption  := IAChartBaseTextClassData.create(FInnerPanel);
  FUserTextField:= IAChartBaseTextClassData.create(FInnerPanel);




  FXAxis.CenterPointTop:=FInnerPanel.Height-40;
  FXAxis.CenterPointLeft:=40;
  FYAxis.CenterPointTop:=FInnerPanel.Height-40;
  FYAxis.CenterPointLeft:=40;
  FYAxis2.CenterPointTop:=FInnerPanel.Height-40;


  FYAxis.AxisType:=iacbatVertical;
  FYAxis2.AxisType:=iacbatVertical;


  FXAxis.SetLength(FInnerPanel.Width-80);
  FYAxis2.CenterPointLeft:=40+FXAxis.Width;
  FYAxis.SetLength(FInnerPanel.Height-80);
  FYAxis2.SetLength(FInnerPanel.Height-80);
  FYAxis2.visible:=false;

  FMainField.Left:=FXAxis.Left+FXAxis.BeginShift;
  FMainField.Top:=FYAxis.Top+FYAxis.EndShift;
  FMainField.Width :=FXAxis.Width-FXAxis.BeginShift-FXAxis.EndShift;
  FMainField.Height:=FYAxis.height-FYAxis.BeginShift-FYAxis.EndShift;

  FXCaption.Top:=FInnerPanel.Height-30;
  FXCaption.Left:=50;
  FYCaption.Left:=0;
  FYCaption.Top:=50;
  FYCaption.TextOrientation:=iacbto_90_Degrees;
  FXCaption.Text:='<U>X Caption';
  FYCaption.Text:='<U>Y Caption';
  FYCaption.Color:=clSilver;
  FXCaption.Color:=clSilver;
  FXCaption.BorderStyle:=iacbbsUp;
  FYCaption.BorderStyle:=iacbbsUp;
  FXCaption.Transparent:=True;
  FYCaption.Transparent:=True;


  FYCaption2.Left:=FYAxis2.left+FYAxis2.Width;
  FYCaption2.Top:=50;
  FYCaption2.TextOrientation:=iacbto_90_Degrees;
  FYCaption2.Text:='<U>Y Caption 2';
  FYCaption2.Color:=clSilver;
  FYCaption2.BorderStyle:=iacbbsUp;
  FYCaption2.Transparent:=True;
  FYCaption2.Visible:=false;

    FXCaption.InnerGap:=2;
  FXCaption.OuterGap:=2;
  FYCaption.InnerGap:=2;
  FYCaption.OuterGap:=2;
  FYCaption2.InnerGap:=2;
  FYCaption2.OuterGap:=2;

  FMainCaption.top:=0;

  FMainCaption.text:='<B>Main Caption';
  FMainCaption.color:=clSilver;
  FMainCaption.Transparent:=True;
  FMainCaption.font.size:=14;
  FMainCaption.left:=(FInnerPanel.width-FMainCaption.width) div 2;
  FMainCaption.BorderStyle:=iacbbsUp;

  if csDesigning  in ComponentState then
    begin
      FLinesField.StringsArray.Add('Here will auto');
      FLinesField.StringsArray.Add('generated lines');
      FLinesField.StringsArray.Add('info.');
      FLinesField.StringsArray.Add('Please no manually');
      FLinesField.StringsArray.Add('change text here.');
      FLinesField.text:=FLinesField.StringsArray.Text;
    end else FLinesField.text:='';


  FLinesField.AutoEditable:=false;
  FLinesField.color:=clSilver;
  FLinesField.Transparent:=True;
  FLinesField.font.size:=10;
  FLinesField.top:=20;
  FLinesField.left:=(FInnerPanel.width-FLinesField.width);
  FLinesField.BorderStyle:=iacbbsDown;

  FUserTextField.StringsArray.Add('User info field');
  FUserTextField.color:=clSilver;
  FUserTextField.Transparent:=True;
  FUserTextField.font.size:=10;
  FUserTextField.top:=FInnerPanel.height-FUserTextField.height-25;
  FUserTextField.left:=(FInnerPanel.width-FUserTextField.width);
  FUserTextField.BorderStyle:=iacbbsDown;


end;

procedure TIAUniChart2D.CreateHandle;
begin
  inherited CreateHandle;
  OldWidth:=FInnerPanel.Width;
  OldHeight:=FInnerPanel.Height;
  isCreated:=True;
  postmessage(FInnerPanel.handle,CM_AXISRECALIBRATED,0,0);
    if not( csDesigning  in componentState )then
    begin
      perform(CM_USERCHANGELINESREPRESENTATION,0,0);
    end;
end;

destructor TIAUniChart2D.Destroy;
begin
  FXAxis.Free;
  FYAxis.Free;
  FYAxis2.free;
  FMainField.free;
  FXCaption.free;
  FYCaption.free;
  FYCaption2.free;
  FLinesField.free;
  FMainCaption.free;
  FUserTextField.free;
  FInnerPanel.free;
  FBackLineDrawBitmap.free;
  FLineImageList.free;
  Inherited Destroy;
end;

function TIAUniChart2D.GetColor: TColor;
begin
  result := inherited Color;
end;
function TIAUniChart2D.GetLColor(Value : Tcolor): Tcolor;
var
 R,G,B : Integer;
 V : Tcolor;

begin
  V:=ColortoRgb(Value);
  R:=(integer(V) shl 24) shr 24;
  G:=(integer(V) shl 16) shr 24;
  B:=(integer(V) shl 8)  shr 24;
  R:=R+32;G:=G+32;B:=B+32;
  if R>255 then R:=255;
  if G>255 then G:=255;
  if B>255 then B:=255;
  Result:=RGB(R,G,B);
end;
function TIAUniChart2D.GetDColor(Value : Tcolor): Tcolor;
var
 R,G,B : Integer;
  V : Tcolor;

begin
  V:=ColortoRgb(Value);
  R:=(integer(V) shl 24) shr 24;
  G:=(integer(V) shl 16) shr 24;
  B:=(integer(V) shl 8)  shr 24;
  R:=R-32;G:=G-32;B:=B-32;
  if R<0 then R:=0;
  if G<0 then G:=0;
  if B<0 then B:=0;
  Result:=RGB(R,G,B);
end;

procedure TIAUniChart2D.Paint;
var
  DColor,LColor : TColor;
  s,i : integer;
begin
  canvas.brush.Color:=FBevelColor;
  Canvas.FillRect(rect(0,0,width,height));
  LColor:=GetLColor(FBevelColor);
  DColor:=GetDColor(FBevelColor);
  s:=FGapOuter;
  case FBevelOuter of
    iacbUp :
      begin
        for i:=0 to FBevelOuterWidth-1 do
          begin
            canvas.pen.Color:=LColor;
            canvas.MoveTo(s+i,height-1-s-i);
            canvas.LineTo(s+i,s+i);
            canvas.LineTo(width-1-s-i,s+i);
            canvas.pen.Color:=DColor;
            canvas.LineTo(width-1-s-i,height-1-s-i);
            canvas.LineTo(s+i,height-1-s-i);
          end;
        s:=s+FBevelOuterWidth;
      end;
    iacbDown :
      begin
        for i:=0 to FBevelOuterWidth-1 do
          begin
            canvas.pen.Color:=DColor;
            canvas.MoveTo(s+i,height-1-s-i);
            canvas.LineTo(s+i,s+i);
            canvas.LineTo(width-1-s-i,s+i);
            canvas.pen.Color:=LColor;
            canvas.LineTo(width-1-s-i,height-1-s-i);
            canvas.LineTo(s+i,height-1-s-i);
          end;
        s:=s+FBevelOuterWidth;
      end;
    iacbUpFlat :
      begin
        for i:=0 to FBevelOuterWidth-1 do
          begin
            if i<=((FBevelOuterWidth) div 2-1) then  canvas.pen.Color:=LColor else canvas.pen.Color:=DColor;
            canvas.MoveTo(s+i,height-1-s-i);
            canvas.LineTo(s+i,s+i);
            canvas.LineTo(width-1-s-i,s+i);
            canvas.pen.Color:=DColor;
            canvas.LineTo(width-1-s-i,height-1-s-i);
            canvas.LineTo(s+i,height-1-s-i);
          end;
        s:=s+FBevelOuterWidth;
      end;
    iacbDownFlat :
      begin
        for i:=0 to FBevelOuterWidth-1 do
          begin
            canvas.pen.Color:=DColor;
            canvas.MoveTo(s+i,height-1-s-i);
            canvas.LineTo(s+i,s+i);
            canvas.LineTo(width-1-s-i,s+i);
            if i<=((FBevelOuterWidth) div 2-1) then  canvas.pen.Color:=LColor else canvas.pen.Color:=DColor;
            canvas.LineTo(width-1-s-i,height-1-s-i);
            canvas.LineTo(s+i,height-1-s-i);
          end;
        s:=s+FBevelOuterWidth;
      end;
  end;
  s:=s+FGapInOut;
    case FBevelInner of
    iacbUp :
      begin
        for i:=0 to FBevelInnerWidth-1 do
          begin
            canvas.pen.Color:=LColor;
            canvas.MoveTo(s+i,height-1-s-i);
            canvas.LineTo(s+i,s+i);
            canvas.LineTo(width-1-s-i,s+i);
            canvas.pen.Color:=DColor;
            canvas.LineTo(width-1-s-i,height-1-s-i);
            canvas.LineTo(s+i,height-1-s-i);
          end;
      end;
    iacbDown :
      begin
        for i:=0 to FBevelInnerWidth-1 do
          begin
            canvas.pen.Color:=DColor;
            canvas.MoveTo(s+i,height-1-s-i);
            canvas.LineTo(s+i,s+i);
            canvas.LineTo(width-1-s-i,s+i);
            canvas.pen.Color:=LColor;
            canvas.LineTo(width-1-s-i,height-1-s-i);
            canvas.LineTo(s+i,height-1-s-i);
          end;
      end;
    iacbUpFlat :
      begin
        for i:=0 to FBevelInnerWidth-1 do
          begin
            if i>((FBevelOuterWidth) div 2-1) then  canvas.pen.Color:=LColor else canvas.pen.Color:=DColor;
            canvas.MoveTo(s+i,height-1-s-i);
            canvas.LineTo(s+i,s+i);
            canvas.LineTo(width-1-s-i,s+i);
            canvas.pen.Color:=DColor;
            canvas.LineTo(width-1-s-i,height-1-s-i);
            canvas.LineTo(s+i,height-1-s-i);
          end;
      end;
    iacbDownFlat :
      begin
        for i:=0 to FBevelInnerWidth-1 do
          begin
            canvas.pen.Color:=DColor;
            canvas.MoveTo(s+i,height-1-s-i);
            canvas.LineTo(s+i,s+i);
            canvas.LineTo(width-1-s-i,s+i);
            if i>((FBevelOuterWidth) div 2-1) then  canvas.pen.Color:=LColor else canvas.pen.Color:=DColor;
            canvas.LineTo(width-1-s-i,height-1-s-i);
            canvas.LineTo(s+i,height-1-s-i);
          end;
      end;
  end;
end;



procedure TIAUniChart2D.SetBevelColor(Value: TColor);
begin
  if Value<>FBevelColor then
    begin
      FBevelColor := Value;
      invalidate;
    end;
end;

procedure TIAUniChart2D.SetBevelInner(Value: TIAChartBevel);
begin
  if Value<>FBevelInner then
    begin
      FBevelInner := Value;
      SetInnerSizes;
      invalidate;
    end;
end;

procedure TIAUniChart2D.SetBevelInnerWidth(Value: byte);
begin
  if Value<>FBevelInnerWidth then
    begin
      FBevelInnerWidth := Value;
      SetInnerSizes;
      invalidate;
    end;
end;

procedure TIAUniChart2D.SetBevelOuter(Value: TIAChartBevel);
begin
  if Value<>FBevelOuter then
    begin
      FBevelOuter := Value;
      SetInnerSizes;
      invalidate;
    end;
end;

procedure TIAUniChart2D.SetBevelOuterWidth(Value: byte);
begin
  if Value<>FBevelOuterWidth then
    begin
      FBevelOuterWidth := Value;
      SetInnerSizes;
      invalidate;
    end;
end;

procedure TIAUniChart2D.SetColor(Value: TColor);
begin
  inherited Color:=Value;
  invalidate;
end;

procedure TIAUniChart2D.SetGapInner(Value: byte);
begin
  if Value<>FGapInner then
    begin
      FGapInner := Value;
      SetInnerSizes;
      invalidate;
    end;
end;

procedure TIAUniChart2D.SetGapInOut(Value: byte);
begin
  if Value<>FGapInOut then
    begin
      FGapInOut := Value;
      SetInnerSizes;
      invalidate;
    end;
end;

procedure TIAUniChart2D.SetGapOuter(Value: byte);
begin
  if Value<>FGapOuter then
    begin
      FGapOuter := Value;
      SetInnerSizes;
      invalidate;
    end;
end;

procedure TIAUniChart2D.SetInnerSizes;
var
  s : Integer;
begin
  s:=FGapInner+FGapInOut+FGapOuter;
  if FBevelOuter<>iacbNone then s:=s+FBevelOuterWidth;
  if FBevelInner<>iacbNone then s:=s+FBevelInnerWidth;
  FInnerPanel.SetBounds(s,s,width-1-2*s,height-1-2*s);
end;

procedure TIAUniChart2D.SetXAxis(Value: IAChartBaseAxisClassData);
begin
  FXAxis.Assign(Value);
end;

procedure TIAUniChart2D.SetXCaption(Value: IAChartBaseTextClassData);
begin
  FXCaption.Assign(Value);
end;

procedure TIAUniChart2D.SetYAxis(Value: IAChartBaseAxisClassData);
begin
  FYAxis.Assign(Value);
end;

procedure TIAUniChart2D.SetYCaption(Value: IAChartBaseTextClassData);
begin
  FYCaption.Assign(Value);
end;

procedure TIAUniChart2D.WMSIZE(var Message: TMessage);
begin
  inherited;
  SetInnerSizes;
end;

procedure TIAUniChart2D.SetResizeReaction(Value: TIAChartResizeReaction);
begin
  if  Value<>FResizeReaction then
    begin
      FResizeReaction := Value;
    end;
end;

procedure TIAUniChart2D.CMRESIZEINNER(var Message: TMessage);
begin
  if isCreated and not((csCreating  in ControlState) or (csReadingState	in ControlState) or
  (csLoading in ComponentState	) or (csReading	 in ComponentState))then
    begin
      dwidth:=FInnerPanel.width-oldwidth;
      dheight:=FInnerPanel.height-oldHeight;


      if FXAxis.AxisType = iacbatVertical   then
        begin
          FYAxis.AxisType:=iacbatHorizontal;
          FYAxis2.AxisType:=iacbatHorizontal;

          FYAxis2.CenterPointLeft:=FYAxis.CenterPointleft;
          FYAxis2.width:=FYAxis.width;
          FYAxis2.BeginShift:=FYAxis.BeginShift;
          FYAxis2.EndShift:=FYAxis.EndShift;
        end else
        begin
          FYAxis.AxisType:=iacbatVertical;
          FYAxis2.AxisType:=iacbatVertical;

          FYAxis2.CenterPointTop:=FYAxis.CenterPointTop;
          FYAxis2.Height:=FYAxis.Height;
          FYAxis2.BeginShift:=FYAxis.BeginShift;
          FYAxis2.EndShift:=FYAxis.EndShift;
        end; 

      case FResizeReaction of
        iacrrNone : begin end;
        iacrrStandart :
          begin
            //Axis
            if  FXAxis.AxisType = iacbatHorizontal then
              begin
                if  FXAxis.CenterPointTop>((oldHeight) div 2) then
                  begin
                    FXAxis.CenterPointTop:=FXAxis.CenterPointTop+dHeight;
                  end;
                if FYAxis.CenterPointleft>((oldwidth) div 2) then
                  begin
                    FYAxis.CenterPointleft:=FYAxis.CenterPointleft+dwidth;
                  end;
                if FYAxis2.CenterPointleft>((oldwidth) div 2) then
                  begin
                    FYAxis2.CenterPointleft:=FYAxis2.CenterPointleft+dwidth;
                  end;
                FYAxis.CenterPointTop:=FYAxis.CenterPointTop+dHeight;
                FYAxis.Height:=FYAxis.Height+dHeight;
                FYAxis2.CenterPointTop:=FYAxis2.CenterPointTop+dHeight;
                FYAxis2.Height:=FYAxis2.Height+dHeight;
                FXAxis.Width:=FXAxis.Width+dwidth;

                FXCaption.left:=FXAxis.left+FXAxis.width div 2 - FXCaption.width div 2;
                if  FXAxis.CenterPointTop>((oldHeight) div 2) then
                  begin
                    FXCaption.top:= FXAxis.top+FXAxis.height;
                  end else
                  begin
                    FXCaption.top:= FXAxis.top-FXCaption.height;
                  end;
                FYCaption.top:=FYAxis.top+FYAxis.height div 2- FYCaption.height div 2;
                if FYAxis.CenterPointleft>((oldwidth) div 2) then
                  begin
                    FYCaption.left:=FYAxis.left+FYAxis.Width;
                  end else
                  begin
                    FYCaption.left:=FYAxis.left-FYCaption.Width;
                  end;
                FYCaption2.top:=FYAxis2.top+FYAxis2.height div 2- FYCaption2.height div 2;
                if FYAxis2.CenterPointleft>((oldwidth) div 2) then
                  begin
                    FYCaption2.left:=FYAxis2.left+FYAxis2.Width;
                  end else
                  begin
                    FYCaption2.left:=FYAxis2.left-FYCaption2.Width;
                  end;
                FMainCaption.left:=FInnerPanel.width div 2 -FMainCaption.width div 2;
                if  FXAxis.CenterPointTop>((oldHeight) div 2) then
                  begin
                    FMainCaption.top:= 0;
                  end else
                  begin
                    FMainCaption.top:= FInnerPanel.height-FMainCaption.Height;
                  end;
                if FYAxis2.visible then
                  begin
                    if FYAxis2.CenterPointleft>((oldwidth) div 2) then
                      begin
                        if FYAxis.CenterPointleft>((oldwidth) div 2) then
                          begin
                            FLinesField.Left:=0;
                            FUserTextField.Left:=0;
                          end else
                          begin

                            FLinesField.Left:=FYAxis2.left-FLinesField.Width;
                            FUserTextField.Left:=FYAxis2.left-FUserTextField.Width;
                          end;

                        if  FXAxis.CenterPointTop>((oldHeight) div 2) then
                          begin
                            FLinesField.top:= FMainCaption.top+FMainCaption.height+10;
                            FUserTextField.top:= FLinesField.top+FLinesField.Height+10;
                          end else
                          begin
                            FLinesField.top:= FMainCaption.top-FLinesField.Height-10;
                            FUserTextField.top:= FLinesField.top-FUserTextField.Height-10;
                          end;
                      end else
                      begin
                        if FYAxis.CenterPointleft>((oldwidth) div 2) then
                          begin
                            FLinesField.Left:=FYAxis.left-FLinesField.width-10;
                            FUserTextField.Left:=FYAxis.left-FUserTextField.width-10;
                          end else
                          begin

                            FLinesField.Left:=oldwidth-FLinesField.width-10;
                            FUserTextField.Left:=oldwidth-FUserTextField.width-10;
                          end;

                        if  FXAxis.CenterPointTop>((oldHeight) div 2) then
                          begin
                            FLinesField.top:= FMainCaption.top+FMainCaption.height+10;
                            FUserTextField.top:= FLinesField.top+FLinesField.Height+10;
                          end else
                          begin
                            FLinesField.top:= FMainCaption.top-FLinesField.Height-10;
                            FUserTextField.top:= FLinesField.top-FUserTextField.Height-10;
                          end;
                      end;
                  end else
                  begin
                    if FYAxis.CenterPointleft>((oldwidth) div 2) then
                      begin
                        FLinesField.Left:=0;
                        FUserTextField.Left:=0;
                      end else
                      begin

                        FLinesField.Left:=FInnerPanel.Width-FLinesField.Width-10;
                        FUserTextField.Left:=FInnerPanel.Width-FUserTextField.Width-10;
                      end;
                    if  FXAxis.CenterPointTop>((oldHeight) div 2) then
                      begin
                        FLinesField.top:= FMainCaption.top+FMainCaption.height+10;
                        FUserTextField.top:= FLinesField.top+FLinesField.Height+10;
                      end else
                      begin
                        FLinesField.top:= FMainCaption.top-FLinesField.Height-10;
                        FUserTextField.top:= FLinesField.top-FUserTextField.Height-10;
                      end;
                  end;
               end else
               begin
                 if FXAxis.CenterPointleft>((oldwidth) div 2) then
                  begin
                    FXAxis.CenterPointleft:=FXAxis.CenterPointleft+dwidth;
                  end;
                 if  FYAxis.CenterPointTop>((oldHeight) div 2) then
                  begin
                    FYAxis.CenterPointTop:=FYAxis.CenterPointTop+dHeight;
                  end;
                 if  FYAxis2.CenterPointTop>((oldHeight) div 2) then
                  begin
                    FYAxis2.CenterPointTop:=FYAxis2.CenterPointTop+dHeight;
                  end;
                 FXAxis.CenterPointTop:=FXAxis.CenterPointTop+dHeight;
                 FXAxis.Height:=FXAxis.Height+dHeight;
                 FYAxis.Width:=FYAxis.Width+dwidth;
                 FYAxis2.Width:=FYAxis2.Width+dwidth;
                FXCaption.top:=FXAxis.top+FXAxis.height div 2- FXCaption.height div 2;
                if FXAxis.CenterPointleft>((oldwidth) div 2) then
                  begin
                    FXCaption.left:=FXAxis.left+FXAxis.Width;
                  end else
                  begin
                    FXCaption.left:=FXAxis.left-FXCaption.Width;
                  end;
                FYCaption.left:=FYAxis.left+FYAxis.width div 2 - FYCaption.width div 2;
                if  FYAxis.CenterPointTop>((oldHeight) div 2) then
                  begin
                    FYCaption.top:= FYAxis.top+FYAxis.height;
                  end else
                  begin
                    FYCaption.top:= FYAxis.top-FYCaption.height;
                  end;
                FYCaption2.left:=FYAxis2.left+FYAxis2.width div 2 - FYCaption2.width div 2;
                 if  FYAxis2.CenterPointTop>((oldHeight) div 2) then
                  begin
                    FYCaption2.top:= FYAxis2.top+FYAxis2.height;
                  end else
                  begin
                    FYCaption2.top:= FYAxis2.top-FYCaption2.height;
                  end;
                FMainCaption.top:=FInnerPanel.height div 2 -FMainCaption.height div 2;
                if  FXAxis.CenterPointLeft>((oldWidth) div 2) then
                  begin
                    FMainCaption.left:= 0;
                  end else
                  begin
                    FMainCaption.left:= FInnerPanel.width-FMainCaption.width;
                  end;
                //--
                if FYAxis2.visible then
                  begin
                    if FYAxis2.CenterPointTop>((oldHeight) div 2) then
                      begin
                        if  FYAxis.CenterPointTop>((oldHeight) div 2) then
                          begin
                            FLinesField.top:=0;
                            FUserTextField.top:=FLinesField.height+10;
                          end else
                          begin
                            FLinesField.top:=FYAxis2.top-FLinesField.height;
                            FUserTextField.top:=FLinesField.top-FLinesField.height-10;
                          end;

                        if  FXAxis.CenterPointLeft>((oldWidth) div 2) then
                          begin
                            FLinesField.left:=FMainCaption.left+FMainCaption.width+10;
                            FUserTextField.left:=FMainCaption.left+FMainCaption.width+10;
                          end else
                          begin
                            FLinesField.left:=FMainCaption.left-FLinesField.Width-10;
                            FUserTextField.left:=FMainCaption.left-FUserTextField.Width-10;
                          end;
                      end else
                      begin
                        if  FYAxis.CenterPointTop>((oldHeight) div 2) then
                          begin
                            FLinesField.top:=FYAxis2.top+FYAxis2.height+10;
                            FUserTextField.top:=FLinesField.top+FLinesField.height+10;
                          end else
                          begin
                            FLinesField.top:=max(FYAxis2.top+FYAxis2.height+10,FYAxis.top+FYAxis.height+10);
                            FUserTextField.top:=FLinesField.top+FLinesField.height+10;
                          end;

                        if  FXAxis.CenterPointLeft>((oldWidth) div 2) then
                          begin
                            FLinesField.left:=FMainCaption.left+FMainCaption.width+10;
                            FUserTextField.left:=FMainCaption.left+FMainCaption.width+10;
                          end else
                          begin
                            FLinesField.left:=FMainCaption.left-FLinesField.Width-10;
                            FUserTextField.left:=FMainCaption.left-FUserTextField.Width-10;
                          end;
                      end;
                  end else
                  begin
                    if  FYAxis.CenterPointTop>((oldHeight) div 2) then
                      begin
                        FLinesField.top:=0;
                        FUserTextField.top:=FLinesField.height+10;
                      end else
                      begin
                        FLinesField.top:=FInnerPanel.Height-FLinesField.height;
                        FUserTextField.top:=FLinesField.top-FLinesField.height-10;
                      end;
                    if  FXAxis.CenterPointLeft>((oldWidth) div 2) then
                      begin
                        FLinesField.left:=FMainCaption.left+FMainCaption.width+10;
                        FUserTextField.left:=FMainCaption.left+FMainCaption.width+10;
                      end else
                      begin
                        FLinesField.left:=FMainCaption.left-FLinesField.Width-10;
                        FUserTextField.left:=FMainCaption.left-FUserTextField.Width-10;
                      end;
                  end;
                  //--
               end;
             {    FXCaption,FYCaption : IAChartBaseTextClassData;

    FLinesField: IAChartBaseTextClassData;
    FMainCaption: IAChartBaseTextClassData;
    FUserTextField: IAChartBaseTextClassData;

    FYCaption2: IAChartBaseTextClassData;}

          end; //standart
      end;

    end;
  oldWidth:=FInnerPanel.width;
  oldheight:=FInnerPanel.height;
end;



procedure TIAUniChart2D.SetLinesField( Value: IAChartBaseTextClassData);
begin
  FLinesField.Assign(Value);
end;

procedure TIAUniChart2D.SetMainCaption( Value: IAChartBaseTextClassData);
begin
  FMainCaption.Assign(Value);
end;

procedure TIAUniChart2D.SetUserTextField(Value: IAChartBaseTextClassData);
begin
  FUserTextField.Assign(Value);
end;

procedure TIAUniChart2D.SetYAxis2(Value: IAChartBaseAxisClassData);
begin
  FYAxis2.Assign(Value);
end;

procedure TIAUniChart2D.SetYCaption2(Value: IAChartBaseTextClassData);
begin
  FYCaption2.Assign(Value);
end;

procedure TIAUniChart2D.SetMainField(Value: IAChartBaseLinesClassData);
begin
  FMainField.Assign(Value);
end;

procedure TIAUniChart2D.CMAXISSIZED(var Message: TMessage);
begin
  //That means Axis sizes changed...
  MainByAxis;
end;

procedure TIAUniChart2D.CMAXISMOVED(var Message: TMessage);
begin
  //Axis were moved...
  MainByAxis;
end;

procedure TIAUniChart2D.CMBASELINESMOVED(var Message: TMessage);
begin
  AxisByMain;
end;

procedure TIAUniChart2D.CMBASELINESSIZED(var Message: TMessage);
begin
  AxisByMain;
end;

procedure TIAUniChart2D.AxisByMain;
begin
  case FXAxis.AxisType of
    iacbatHorizontal :
      begin
        FXAxis.Left:=FMainField.Left-FXAxis.BeginShift;
        FXAxis.Width:=FMainField.width+FXAxis.BeginShift+FXAxis.EndShift;
        FYAxis.Height:=FMainField.height+FYAxis.BeginShift+FYAxis.EndShift;
        FYAxis.CenterPointTop:=FYAxis.CenterPointTop+(FMainField.Top-FYAxis.EndShift)-FYAxis.top;

      end;
    iacbatVertical :
      begin
        FYAxis.Left:=FMainField.Left-FYAxis.BeginShift;
        FYAxis.Width:=FMainField.width+FYAxis.BeginShift+FYAxis.EndShift;
        FXAxis.Height:=FMainField.height+FXAxis.BeginShift+FXAxis.EndShift;
        FXAxis.CenterPointTop:=FXAxis.CenterPointTop+(FMainField.Top-FXAxis.EndShift)-FXAxis.top;

      end;
  end;
end;

procedure TIAUniChart2D.MainByAxis;
begin
  case FXAxis.AxisType of
    iacbatHorizontal :
      begin
        FMainField.Left:=FXAxis.Left+FXAxis.BeginShift;
        FMainField.Top:=FYAxis.Top+FYAxis.EndShift;
        FMainField.Width :=FXAxis.Width-FXAxis.BeginShift-FXAxis.EndShift;
        FMainField.Height:=FYAxis.height-FYAxis.BeginShift-FYAxis.EndShift;
      end;
    iacbatVertical :
      begin
        FMainField.Left:=FYAxis.Left+FYAxis.BeginShift;
        FMainField.Top:=FXAxis.Top+FXAxis.EndShift;
        FMainField.Width :=FYAxis.Width-FYAxis.BeginShift-FYAxis.EndShift;
        FMainField.Height:=FXAxis.height-FXAxis.BeginShift-FXAxis.EndShift;
      end;
  end;
end;



procedure TIAUniChart2D.CMAXISRECALIBRATED(var Message: TMessage);
begin
  DefMainDiapason(IAChartBaseLinesClass(Message.LParam));
end;

procedure TIAUniChart2D.DefMainDiapason(AMain : IAChartBaseLinesClass);
begin
  if assigned(AMain) then
    begin
      AMain.XAxisType:=FXAxis.AxisType;

      AMain.XAxisBegin:=XAxis.GetRealBeginValue;
      AMain.XAxisEnd:=XAxis.GetRealEndvalue;
      AMain.XAxisStyle:=XAxis.ScaleStyle;
      if XAxis.Visible then AMain.XAxisStep:=XAxis.GetCurrStep else AMain.XAxisStep:=0;

      AMain.YAxisBegin:=YAxis.GetRealBeginValue;
      AMain.YAxisEnd:=YAxis.GetRealEndvalue;
      AMain.YAxisStyle:=YAxis.ScaleStyle;
      if YAxis.Visible then AMain.YAxisStep:=YAxis.GetCurrStep else AMain.YAxisStep:=0;

      AMain.YAxis2Begin:=YAxis2.GetRealBeginValue;
      AMain.YAxis2End:=YAxis2.GetRealEndvalue;
      AMain.YAxis2Style:=YAxis2.ScaleStyle;
      if YAxis2.Visible then AMain.YAxis2Step:=YAxis2.GetCurrStep else AMain.YAxis2Step:=0;
    end;
end;

procedure TIAUniChart2D.AutoRecalibrate(AReservePercent: double);
var Xmin,XMax,Ymin,YMax,Ymin2,Ymax2,R1,R2 : double;
    i,j : integer;
begin
  if (self.MainField.MainDataArray.LinesNumber>0) and
     (self.MainField.MainDataArray.DataNumber>0) then
    begin
      Xmin:=0;Xmax:=self.MainField.MainDataArray.DataNumber-1;
      for i:=0 to self.MainField.MainDataArray.LinesNumber-1 do
        begin
          if  ((self.MainField.MainDataArray.Lines[i].LineType=iacbltYData) or
              (self.MainField.MainDataArray.Lines[i].LineType=iacbltY2Data)) and
              ((self.MainField.MainDataArray.Lines[i].XLine>=0) and
               (self.MainField.MainDataArray.Lines[i].XLine<self.MainField.MainDataArray.LinesNumber))then
            begin
              XMin:=self.MainField.MainDataArray.Lines[self.MainField.MainDataArray.Lines[i].XLine].Data[0];
              XMax:=self.MainField.MainDataArray.Lines[self.MainField.MainDataArray.Lines[i].XLine].Data[0];

              break;
            end;
        end;
      for i:=0 to self.MainField.MainDataArray.LinesNumber-1 do
        begin
          if  ((self.MainField.MainDataArray.Lines[i].LineType=iacbltYData) or
              (self.MainField.MainDataArray.Lines[i].LineType=iacbltY2Data)) and
              ((self.MainField.MainDataArray.Lines[i].XLine>=0) and
               (self.MainField.MainDataArray.Lines[i].XLine<self.MainField.MainDataArray.LinesNumber))then
            begin
              for j:=0 to self.MainField.MainDataArray.DataNumber-1 do
                begin
                  if XMin> self.MainField.MainDataArray.Lines[self.MainField.MainDataArray.Lines[i].XLine].Data[j] then
                     XMin:=self.MainField.MainDataArray.Lines[self.MainField.MainDataArray.Lines[i].XLine].Data[j];
                  if XMax< self.MainField.MainDataArray.Lines[self.MainField.MainDataArray.Lines[i].XLine].Data[j] then
                     XMax:=self.MainField.MainDataArray.Lines[self.MainField.MainDataArray.Lines[i].XLine].Data[j];
                end;
            end;
        end;
       for i:=0 to self.MainField.MainDataArray.LinesNumber-1 do
        begin
          if  (self.MainField.MainDataArray.Lines[i].LineType=iacbltYData) or
              (self.MainField.MainDataArray.Lines[i].LineType=iacbltY2Data)then
            begin
              if (self.MainField.MainDataArray.Lines[i].XLine<0) or
                 (self.MainField.MainDataArray.Lines[i].XLine>=self.MainField.MainDataArray.LinesNumber)
                then
                  begin
                    if XMin> 0 then
                     XMin:=0;
                    if XMax< (self.MainField.MainDataArray.DataNumber-1) then
                       XMax:=self.MainField.MainDataArray.DataNumber-1;

                  end;
            end;
        end;
      //Defined XAxis Diapason
      //Take the reserve
      R1:=Xmin-(XMax-XMin)*AReservePercent/100;
      R2:=Xmax+(XMax-XMin)*AReservePercent/100;
      XMin:=R1;
      XMax:=R2;
      self.XAxis.BeginValue:=XMin;
      self.XAxis.EndValue:=XMax;
      YMin:=0;YMax:=0;
      for i:=0 to self.MainField.MainDataArray.LinesNumber-1 do
        begin
          if  self.MainField.MainDataArray.Lines[i].LineType=iacbltYData then
            begin
              YMin:=self.MainField.MainDataArray.Lines[i].Data[0];
              YMax:=self.MainField.MainDataArray.Lines[i].Data[0];
              break;
            end;
        end;
      for i:=0 to self.MainField.MainDataArray.LinesNumber-1 do
        begin
          if  self.MainField.MainDataArray.Lines[i].LineType=iacbltYData then
            begin
              for j:=0 to self.MainField.MainDataArray.DataNumber-1 do
                begin
                  if YMin> self.MainField.MainDataArray.Lines[i].Data[j] then
                     YMin:=self.MainField.MainDataArray.Lines[i].Data[j];
                  if YMax< self.MainField.MainDataArray.Lines[i].Data[j] then
                     YMax:=self.MainField.MainDataArray.Lines[i].Data[j];
                end;
            end;
        end;
      //Defined YAxis Diapason
      //Take the reserve
      R1:=Ymin-(YMax-YMin)*AReservePercent/100;
      R2:=Ymax+(YMax-YMin)*AReservePercent/100;
      YMin:=R1;
      YMax:=R2;
      self.YAxis.BeginValue:=YMin;
      self.YAxis.EndValue:=YMax;

       YMin2:=0;YMax2:=0;
      for i:=0 to self.MainField.MainDataArray.LinesNumber-1 do
        begin
          if  self.MainField.MainDataArray.Lines[i].LineType=iacbltY2Data then
            begin
              YMin2:=self.MainField.MainDataArray.Lines[i].Data[0];
              YMax2:=self.MainField.MainDataArray.Lines[i].Data[0];
              break;
            end;
        end;
      for i:=0 to self.MainField.MainDataArray.LinesNumber-1 do
        begin
          if  self.MainField.MainDataArray.Lines[i].LineType=iacbltY2Data then
            begin
              for j:=0 to self.MainField.MainDataArray.DataNumber-1 do
                begin
                  if YMin2> self.MainField.MainDataArray.Lines[i].Data[j] then
                     YMin2:=self.MainField.MainDataArray.Lines[i].Data[j];
                  if YMax2< self.MainField.MainDataArray.Lines[i].Data[j] then
                     YMax2:=self.MainField.MainDataArray.Lines[i].Data[j];
                end;
            end;
        end;
      //Defined YAxis Diapason
      //Take the reserve
      R1:=Ymin2-(YMax2-YMin2)*AReservePercent/100;
      R2:=Ymax2+(YMax2-YMin2)*AReservePercent/100;
      YMin2:=R1;
      YMax2:=R2;
      self.YAxis2.BeginValue:=YMin2;
      self.YAxis2.EndValue:=YMax2;
    end else
    begin
      self.XAxis.BeginValue:=0;
      self.XAxis.EndValue:=0;
      self.yAxis.BeginValue:=0;
      self.YAxis.EndValue:=0;
      self.YAxis2.BeginValue:=0;
      self.YAxis2.EndValue:=0;
    end;
end;

procedure TIAUniChart2D.CMUSERWANTSRESIZE(var Message: TMessage);
var Amin,AMax,AWMin,AWMax: Double;
begin
  case XAxis.AxisType of
    iacbatHorizontal :
      begin
        case self.XAxis.ScaleStyle of
          iacbasLinear :
            begin
              AMin:=XAxis.GetRealBeginValue;
              AMax:=XAxis.GetRealEndvalue;
              if AMin<AMax then
                begin
                  AWMin:=AMin+(AMax-AMin)*IAChartBaseLinesClass(Message.WParam).ASelectRect.left/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.left);
                  AWMax:=AMin+(AMax-AMin)*IAChartBaseLinesClass(Message.WParam).ASelectRect.right/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.left);
                  XAxis.BeginValue:=AWMin;
                  XAxis.EndValue:=AWMax;
                end else
                begin
                  AWMin:=AMin+(AMax-AMin)*
                          (IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                           IAChartBaseLinesClass(Message.WParam).ASelectRect.right)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.left);
                  AWMax:=AMin+(AMax-AMin)*(IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                           IAChartBaseLinesClass(Message.WParam).ASelectRect.left)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.left);
                  XAxis.BeginValue:=AWMin;
                  XAxis.EndValue:=AWMax;
                end;
            end;
        end;
        case self.YAxis.ScaleStyle of
          iacbasLinear :
            begin
              AMin:=YAxis.GetRealBeginValue;
              AMax:=YAxis.GetRealEndvalue;
              if AMin<AMax then
                begin
                  AWMin:=AMin+(AMax-AMin)*
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).ASelectRect.Bottom)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.Top);
                  AWMax:=AMin+(AMax-AMin)*(IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).ASelectRect.top)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.Top);
                  YAxis.BeginValue:=AWMin;
                  YAxis.EndValue:=AWMax;
                end else
                begin
                  AWMin:=AMin+(AMax-AMin)*
                         (
                         IAChartBaseLinesClass(Message.WParam).ASelectRect.top)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.Top);
                  AWMax:=AMin+(AMax-AMin)*(
                         IAChartBaseLinesClass(Message.WParam).ASelectRect.Bottom)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.Top);
                  YAxis.BeginValue:=AWMin;
                  YAxis.EndValue:=AWMax;
                end;
            end;
        end;
        case self.YAxis2.ScaleStyle of
          iacbasLinear :
            begin
              AMin:=YAxis2.GetRealBeginValue;
              AMax:=YAxis2.GetRealEndvalue;
              if AMin<AMax then
                begin
                  AWMin:=AMin+(AMax-AMin)*
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).ASelectRect.Bottom)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.Top);
                  AWMax:=AMin+(AMax-AMin)*(IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).ASelectRect.top)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.Top);
                  YAxis2.BeginValue:=AWMin;
                  YAxis2.EndValue:=AWMax;
                end else
                begin
                  AWMin:=AMin+(AMax-AMin)*
                         (
                         IAChartBaseLinesClass(Message.WParam).ASelectRect.top)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.Top);
                  AWMax:=AMin+(AMax-AMin)*(
                         IAChartBaseLinesClass(Message.WParam).ASelectRect.Bottom)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.Top);
                  YAxis2.BeginValue:=AWMin;
                  YAxis2.EndValue:=AWMax;
                end;
            end;
        end;
      end;
    iacbatVertical :
      begin
        case self.XAxis.ScaleStyle of
          iacbasLinear :
            begin
              AMin:=XAxis.GetRealBeginValue;
              AMax:=XAxis.GetRealEndvalue;
              if AMin<AMax then
                begin
                  AWMin:=AMin+(AMax-AMin)*
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).ASelectRect.Bottom)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.Top);
                  AWMax:=AMin+(AMax-AMin)*(IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).ASelectRect.top)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.Top);
                  XAxis.BeginValue:=AWMin;
                  XAxis.EndValue:=AWMax;
                end else
                begin
                  AWMin:=AMin+(AMax-AMin)*
                         (
                         IAChartBaseLinesClass(Message.WParam).ASelectRect.top)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.Top);
                  AWMax:=AMin+(AMax-AMin)*(
                         IAChartBaseLinesClass(Message.WParam).ASelectRect.Bottom)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.Bottom-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.Top);
                  XAxis.BeginValue:=AWMin;
                  XAxis.EndValue:=AWMax;
                end;
            end;
        end;
        case self.YAxis.ScaleStyle of
          iacbasLinear :
            begin
              AMin:=YAxis.GetRealBeginValue;
              AMax:=YAxis.GetRealEndvalue;
              if AMin<AMax then
                begin
                  AWMin:=AMin+(AMax-AMin)*IAChartBaseLinesClass(Message.WParam).ASelectRect.left/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.left);
                  AWMax:=AMin+(AMax-AMin)*IAChartBaseLinesClass(Message.WParam).ASelectRect.right/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.left);
                  YAxis.BeginValue:=AWMin;
                  YAxis.EndValue:=AWMax;
                end else
                begin
                  AWMin:=AMin+(AMax-AMin)*
                          (IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                           IAChartBaseLinesClass(Message.WParam).ASelectRect.right)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.left);
                  AWMax:=AMin+(AMax-AMin)*(IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                           IAChartBaseLinesClass(Message.WParam).ASelectRect.left)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.left);
                  YAxis.BeginValue:=AWMin;
                  YAxis.EndValue:=AWMax;
                end;
            end;
        end;
        case self.YAxis2.ScaleStyle of
          iacbasLinear :
            begin
              AMin:=YAxis2.GetRealBeginValue;
              AMax:=YAxis2.GetRealEndvalue;
              if AMin<AMax then
                begin
                  AWMin:=AMin+(AMax-AMin)*IAChartBaseLinesClass(Message.WParam).ASelectRect.left/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.left);
                  AWMax:=AMin+(AMax-AMin)*IAChartBaseLinesClass(Message.WParam).ASelectRect.right/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.left);
                  YAxis2.BeginValue:=AWMin;
                  YAxis2.EndValue:=AWMax;
                end else
                begin
                  AWMin:=AMin+(AMax-AMin)*
                          (IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                           IAChartBaseLinesClass(Message.WParam).ASelectRect.right)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.left);
                  AWMax:=AMin+(AMax-AMin)*(IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                           IAChartBaseLinesClass(Message.WParam).ASelectRect.left)/
                         (IAChartBaseLinesClass(Message.WParam).AMainRect.right-
                         IAChartBaseLinesClass(Message.WParam).AMainRect.left);
                  YAxis2.BeginValue:=AWMin;
                  YAxis2.EndValue:=AWMax;
                end;
            end;
        end;
      end;
  end;
end;

procedure TIAUniChart2D.CMUSERCHANGELINESREPRESENTATION(
  var Message: TMessage);
 var i,N,Sn,k : integer;
     FBaseBitmap : TBitmap;
     ABitmap : TBitmap;
begin
  //Here we auto generate the lines info
  N:=0;Sn:=0;
  for i:=0 to self.MainField.MainDataArray.LinesNumber-1 do
    begin
      if (self.MainField.MainDataArray.Lines[i].LineType=iacbltYData) or
         (self.MainField.MainDataArray.Lines[i].LineType=iacbltY2Data) then
           begin
             inc(N);
             if SN<self.MainField.MainDataArray.Lines[i].pointsize then
                SN:=self.MainField.MainDataArray.Lines[i].pointsize;
           end;
    end;
  self.LinesField.Text:='';
  if self.MainField.MainDataArray.CommonInfo<>'' then
  self.LinesField.StringsArray.Add(self.MainField.MainDataArray.CommonInfo);
  if N=0 then
    begin
      LinesField.Text:=LinesField.StringsArray.text;
      exit;
    end;
  if SN=0 then
    begin
      LinesField.CurrImageList:=nil;
      for i:=0 to self.MainField.MainDataArray.LinesNumber-1 do
        begin
          if (self.MainField.MainDataArray.Lines[i].LineType=iacbltYData) or
             (self.MainField.MainDataArray.Lines[i].LineType=iacbltY2Data) then
               begin
                 self.LinesField.StringsArray.Add(self.MainField.MainDataArray.Lines[i].InfoString);
               end;
        end;
    end else
    begin
      FBaseBitmap:=TBitmap.Create;
      FBaseBitmap.PixelFormat:=pf24Bit;
      if FBackLineDrawBitmap.width=0 then
        begin
          FBaseBitmap.Height:=2*sn;
          FBaseBitmap.width:=6*sn;
          if MainField.Transparent then FBaseBitmap.Canvas.brush.color:=Color else
          FBaseBitmap.Canvas.brush.color:=MainField.Color;
          FBaseBitmap.Canvas.FillRect(rect(0,0,FBaseBitmap.width,FBaseBitmap.height));
        end else
        begin
          FBaseBitmap.Height:=FBackLineDrawBitmap.height;
          FBaseBitmap.width:=FBackLineDrawBitmap.Width;
          FBaseBitmap.Canvas.Draw(0,0,FBackLineDrawBitmap);
        end;
      FLineImageList.Clear;
      FLineImageList.BKColor:=clNone;
      if FbackLineBitmapTransparent then FLineImageList.Masked:=true else FLineImageList.Masked:=false;
      FLineImageList.Width :=FBaseBitmap.width;
      FLineImageList.Height:=FBaseBitmap.Height;
      for i:=0 to N-1 do
        begin
          ABitmap:=GetPointedBitmap(FBaseBitmap,i);
          FLineImageList.AddMasked(ABitmap,ABitmap.canvas.Pixels[0,0]);
          ABitmap.free;
        end;

      k:=0;
      for i:=0 to self.MainField.MainDataArray.LinesNumber-1 do
        begin
          if (self.MainField.MainDataArray.Lines[i].LineType=iacbltYData) or
             (self.MainField.MainDataArray.Lines[i].LineType=iacbltY2Data) then
               begin
                 self.LinesField.StringsArray.Add(SysWords[12]+inttostr(k)+SysWords[13]+
                                        self.MainField.MainDataArray.Lines[i].InfoString);
                 inc(K);
               end;
        end;
      LinesField.CurrImageList:=FLineImageList;
      LinesField.Text:=LinesField.StringsArray.text;
      FBaseBitmap.free;
    end;
end;

procedure TIAUniChart2D.SetBackLineDrawBitmap(Value: TBitmap);
begin
  if (Value<>nil) and (assigned(Value)) and (Value.width>0)then
    begin
      FBackLineDrawBitmap.width:=Value.width;
      FBackLineDrawBitmap.height:=Value.height;
      FBackLineDrawBitmap.canvas.draw(0,0,Value);
    end else
    begin
      FBackLineDrawBitmap.width:=0;
      FBackLineDrawBitmap.height:=0;
    end;
  perform(CM_USERCHANGELINESREPRESENTATION,0,0);
end;

procedure TIAUniChart2D.SetbackLineBitmapTransparent(Value: Boolean);
begin
  if FbackLineBitmapTransparent<>Value then
    begin
      FbackLineBitmapTransparent := Value;
      LinesField.Text:=LinesField.StringsArray.text;
    end;
end;

function TIAUniChart2D.GetPointedBitmap(ABitmap: TBitmap;N: integer): TBitmap;
var i,k,x,y : integer;
begin
  result:=TBitmap.Create;
  result.Width:=ABitmap.width;
  result.Height:=ABitmap.height;
  result.pixelFormat:=pf24Bit;
  result.Canvas.Draw(0,0,ABitmap);
  k:=0;
  for i:=0 to self.MainField.MainDataArray.LinesNumber-1 do
    begin
      if (self.MainField.MainDataArray.Lines[i].LineType=iacbltYData) or
         (self.MainField.MainDataArray.Lines[i].LineType=iacbltY2Data) then
           begin
             if k=n then
               begin
                 if self.MainField.MainDataArray.Lines[i].LineStyle<>iacblsNone then
                   begin
                     result.Canvas.Pen.color:=self.MainField.MainDataArray.Lines[i].LineColor;
                     result.Canvas.Moveto(0,result.height div 2);
                     result.Canvas.Lineto(result.width,result.height div 2);
                   end;
                 x:=result.width div 2;
                 y:=result.height div 2;  
                 case self.MainField.MainDataArray.Lines[i].PointType of
                   iacblptCircle :
                     begin
                       result.Canvas.pen.color:=self.MainField.MainDataArray.Lines[i].PointColor;
                       result.Canvas.brush.Style:=bsClear;
                       result.Canvas.Ellipse(x-self.MainField.MainDataArray.Lines[i].PointSize div 2,
                                             y-self.MainField.MainDataArray.Lines[i].PointSize div 2,
                                             x+self.MainField.MainDataArray.Lines[i].PointSize div 2,
                                             y+self.MainField.MainDataArray.Lines[i].PointSize div 2);
                       result.Canvas.brush.Style:=bsSolid;
                     end;
                   iacblptSquare :
                     begin
                       result.Canvas.pen.color:=self.MainField.MainDataArray.Lines[i].PointColor;
                       result.Canvas.brush.Style:=bsClear;
                       result.Canvas.Rectangle(x-self.MainField.MainDataArray.Lines[i].PointSize div 2,
                                               y-self.MainField.MainDataArray.Lines[i].PointSize div 2,
                                               x+self.MainField.MainDataArray.Lines[i].PointSize div 2,
                                               y+self.MainField.MainDataArray.Lines[i].PointSize div 2);
                       result.Canvas.brush.Style:=bsSolid;
                     end;
                   iacblptTriangle :
                     begin
                       result.Canvas.pen.color:=self.MainField.MainDataArray.Lines[i].PointColor;
                       result.Canvas.brush.Style:=bsClear;
                       result.Canvas.MoveTo(x,y-self.MainField.MainDataArray.Lines[i].PointSize div 2);
                       result.Canvas.LineTo(x+self.MainField.MainDataArray.Lines[i].PointSize div 2,
                       y+self.MainField.MainDataArray.Lines[i].PointSize div 2);
                       result.Canvas.LineTo(x-self.MainField.MainDataArray.Lines[i].PointSize div 2,
                       y+self.MainField.MainDataArray.Lines[i].PointSize div 2);
                       result.Canvas.LineTo(x,y-self.MainField.MainDataArray.Lines[i].PointSize div 2);
                       result.Canvas.brush.Style:=bsSolid;
                     end;
                 end;
                 break;
               end;
             inc(k);
           end;
    end;
end;

function TIAUniChart2D.GetChartBitmap: TBitmap;
  var i : integer;
    ACanvas : TControlCanvas;
    ARect,ARect2 : TRect;
begin
  result:=TBitmap.Create;
  result.PixelFormat:=pf24Bit;
  Result.Width:=width;
  result.height:=height;
  self.PaintTo(result.canvas.handle,0,0);
  for i:=0 to finnerpanel.ControlCount-1 do
    begin

      if finnerpanel.Controls[i] is TGraphicControl then
        begin
          ACanvas:=TControlCanvas.Create;
          ACanvas.Control:=finnerpanel.Controls[i];
          (finnerpanel.Controls[i] as TGraphicControl).repaint;
          ARect:=Rect(0,0,(finnerpanel.Controls[i] as TGraphicControl).width,
          (finnerpanel.Controls[i] as TGraphicControl).height);
          ARect2:=Rect(0,0,(finnerpanel.Controls[i] as TGraphicControl).width,
          (finnerpanel.Controls[i] as TGraphicControl).height);
          offsetrect(ARect,
          finnerpanel.Controls[i].clientorigin.x-clientorigin.x,
          finnerpanel.Controls[i].clientorigin.y-clientorigin.y);


          Result.canvas.CopyRect(ARect,ACanvas,ARect2);
          ACanvas.free;
        end;
    end;
end;

procedure TIAUniChart2D.SaveAsBitmapAT(AFileName: String);
var ABitmap : TBitmap;
begin
  ABitmap:=GetChartBitmap;
  ABitmap.SaveToFile(AFileName);
  ABitmap.free;
end;

procedure TIAUniChart2D.CopyChartToClipBoard;
var ABitmap : TBitmap;
    AFormat: Word;
    AData: THandle;
    APalette: HPALETTE;
begin
  ABitmap:=GetChartBitmap;
  try
  ABitmap.SaveToClipboardFormat(AFormat,AData,APalette);
  ClipBoard.SetAsHandle(AFormat,AData);
  except

  end;
  ABitmap.free;
end;

procedure TIAUniChart2D.CMUSERDBLCLICK(var Message: TMessage);
var CurrObj : IAChartBaseMovingClass;
begin
  CurrObj:=IAChartBaseMovingClass(Message.WParam);
  if CurrObj is IAChartBaseTextClass then
    begin
      if XCaption.IsYours(CurrObj as IAChartBaseTextClass) then
        begin
          if Assigned(FOnXAxisCaptionDblClick) then FOnXAxisCaptionDblClick(self);
        end else
        begin
          if YCaption.IsYours(CurrObj as IAChartBaseTextClass) then
            begin
              if Assigned(FOnYAxisCaptionDblClick) then FOnYAxisCaptionDblClick(self);
            end else
            begin
              if YCaption2.IsYours(CurrObj as IAChartBaseTextClass) then
                begin
                  if Assigned(FOnYAxis2CaptionDblClick) then FOnYAxis2CaptionDblClick(self);
                end else
                begin
                  if MainCaption.IsYours(CurrObj as IAChartBaseTextClass) then
                    begin
                      if Assigned(FOnMainCaptionDblClick) then FOnMainCaptionDblClick(self);
                    end else
                    begin
                      if UserTextField.IsYours(CurrObj as IAChartBaseTextClass) then
                        begin
                          if Assigned(FOnUserInfoFieldDblClick) then FOnUserInfoFieldDblClick(self);
                        end else
                        begin
                          if LinesField.IsYours(CurrObj as IAChartBaseTextClass) then
                             begin
                               if Assigned(FOnLinesInfoFieldDblClick) then FOnLinesInfoFieldDblClick(self);
                             end else
                             begin
                               //no action
                             end;
                        end;
                    end;
                end;
            end;
        end;
    end else
    begin
      if CurrObj is IAChartBaseLinesClass then
        begin
          if Assigned(FOnMainFieldDblClick) then FOnMainFieldDblClick(self);
        end;
    end;

end;

procedure TIAUniChart2D.SetOnLinesInfoFieldDblClick(Value: TNotifyEvent);
begin
  FOnLinesInfoFieldDblClick := Value;
end;

procedure TIAUniChart2D.SetOnMainCaptionDblClick(Value: TNotifyEvent);
begin
  FOnMainCaptionDblClick := Value;
end;

procedure TIAUniChart2D.SetOnMainFieldDblClick(Value: TNotifyEvent);
begin
  FOnMainFieldDblClick := Value;
end;

procedure TIAUniChart2D.SetOnUserInfoFieldDblClick(Value: TNotifyEvent);
begin
  FOnUserInfoFieldDblClick := Value;
end;

procedure TIAUniChart2D.SetOnXAxisCaptionDblClick(Value: TNotifyEvent);
begin
  FOnXAxisCaptionDblClick := Value;
end;

procedure TIAUniChart2D.SetOnXAxisDblClick(Value: TNotifyEvent);
begin
  FOnXAxisDblClick := Value;
end;

procedure TIAUniChart2D.SetOnYAxis2CaptionDblClick(Value: TNotifyEvent);
begin
  FOnYAxis2CaptionDblClick := Value;
end;

procedure TIAUniChart2D.SetOnYAxis2DblClick(Value: TNotifyEvent);
begin
  FOnYAxis2DblClick := Value;
end;

procedure TIAUniChart2D.SetOnYAxisCaptionDblClick(Value: TNotifyEvent);
begin
  FOnYAxisCaptionDblClick := Value;
end;

procedure TIAUniChart2D.SetOnYAxisDblClick(Value: TNotifyEvent);
begin
  FOnYAxisDblClick := Value;
end;

procedure TIAUniChart2D.CMAXISDBLCLICKED(var Message: TMessage);
var CurrObj : IAChartBaseAxisClass;
begin
  CurrObj:=IAChartBaseAxisClass(Message.WParam);
  if XAxis.IsYours(CurrObj) then
    begin
      if Assigned(FOnXAxisDblClick) then FOnXAxisDblClick(self);
    end else
    begin
      if YAxis.IsYours(CurrObj) then
        begin
          if Assigned(FOnYAxisDblClick) then FOnYAxisDblClick(self);
        end else
        begin
          if YAxis2.IsYours(CurrObj) then
            begin
              if Assigned(FOnYAxis2DblClick) then FOnYAxis2DblClick(self);
            end else
            begin
              //no action
            end;
        end;
    end;
end;

procedure TIAUniChart2D.Loaded;
begin
  inherited Loaded;
end;

procedure TIAUniChart2D.Assign(Source: TPersistent);
begin
if Source is TIAUniChart2D then
    begin

//      AxisType:=(Source as TIAUniChart2D).AxisType;
    Width:=(Source as TIAUniChart2D).Width;
    Height:=(Source as TIAUniChart2D).Height;


    BevelInner:=(Source as TIAUniChart2D).BevelInner;
    BevelOuter:=(Source as TIAUniChart2D).BevelOuter;
    Color:=(Source as TIAUniChart2D).Color;
    BevelInnerWidth:=(Source as TIAUniChart2D).BevelInnerWidth;
    BevelOuterWidth:=(Source as TIAUniChart2D).BevelOuterWidth;
    GapInner:=(Source as TIAUniChart2D).GapInner;
    GapOuter:=(Source as TIAUniChart2D).GapOuter;
    GapInOut:=(Source as TIAUniChart2D).GapInOut;
    BevelColor:=(Source as TIAUniChart2D).BevelColor;
    ResizeReaction:=(Source as TIAUniChart2D).ResizeReaction;
    BackLineBitmapTransparent:=(Source as TIAUniChart2D).BackLineBitmapTransparent;
    FInnerPanel.Assign((Source as TIAUniChart2D).FInnerPanel);

    MainField:=(Source as TIAUniChart2D).MainField;
    XCaption:=(Source as TIAUniChart2D).XCaption;
    YCaption:=(Source as TIAUniChart2D).YCaption;
    YCaption2:=(Source as TIAUniChart2D).YCaption2;
    XAxis:=(Source as TIAUniChart2D).XAxis;
    YAxis:=(Source as TIAUniChart2D).YAxis;
    YAxis2:=(Source as TIAUniChart2D).YAxis2;
    MainCaption:=(Source as TIAUniChart2D).MainCaption;
    UserTextField:=(Source as TIAUniChart2D).UserTextField;
    LinesField:=(Source as TIAUniChart2D).LinesField;
    BackLineDrawBitmap:=(Source as TIAUniChart2D).BackLineDrawBitmap;

      //(self as TCustomControl).Assign((Source as TCustomControl));

    end else
    begin
      inherited Assign(Source);
    end;
end;

function TIAUniChart2D.GetInnerHeight: Integer;
begin
  result:=FInnerPanel.ClientHeight;
end;

function TIAUniChart2D.GetInnerWidth: integer;
begin
  result:=FInnerPanel.ClientWidth;
end;

procedure TIAUniChart2D.Reasseble;
begin
  sendmessage(parent.handle,CM_RESIZEINNER,0,0);
end;

{ TIAChartInnerPanel }

procedure TIAChartInnerPanel.CMAXISCLICKED(var Message: TWMLButtonDown);
begin
  //
end;

procedure TIAChartInnerPanel.CMAXISMOVED(var Message: TMessage);
begin
  if assigned(parent) and parent.HandleAllocated then
      begin
        sendmessage(parent.handle,CM_RESIZEINNER,0,0);
        sendmessage(parent.handle,CM_AXISMOVED,Message.WParam,0);
      end;
end;

procedure TIAChartInnerPanel.CMNEWFONT(var Message: TMessage);
var i : integer;
begin
  for i:=0 to self.ControlCount-1 do
    begin
      if (self.Controls[i] is IAChartBaseAxisClass)
          and
         (not FontsIsEqual((self.Controls[i] as IAChartBaseAxisClass).font,IAChartBaseAxisClass(Message.WParam).font))
         then
         (self.Controls[i] as IAChartBaseAxisClass).font:=IAChartBaseAxisClass(Message.WParam).font;
    end;
end;

procedure TIAChartInnerPanel.CMORIENTATIONCHANGED(var Message: TMessage);
begin
  if assigned(parent) and parent.HandleAllocated then
    postmessage(parent.handle,CM_RESIZEINNER,0,0);
end;

procedure TIAChartInnerPanel.CMAXISSIZED(var Message: TMessage);
begin
    if assigned(parent) and parent.HandleAllocated then
      begin
        sendmessage(parent.handle,CM_RESIZEINNER,0,0);
        sendmessage(parent.handle,CM_AXISSIZED,Message.WParam,0);
      end;
end;

constructor TIAChartInnerPanel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

destructor TIAChartInnerPanel.Destroy;
begin
  inherited Destroy;
end;

function TIAChartInnerPanel.FontsIsEqual(F1, F2: TFont): Boolean;
begin
  result:=True;
  if F1.Name<>F2.Name then result:=false;
  if F1.Size<>F2.Size then result:=false;
  if F1.Color<>F2.Color then result:=false;
  if F1.Style<>F2.Style then result:=false;
end;

procedure TIAChartInnerPanel.Paint;
begin
  if assigned(Parent) and (parent.handle<>0) then sendmessage(parent.handle,CM_DRAWINNER,0,0);
end;

procedure TIAChartInnerPanel.WMLButtonDown(var Message: TWMLButtonDown);
  var i : integer;
begin
  inherited;
  for i:=0 to self.ControlCount-1 do
    begin
      if (self.controls[i] is IAChartBaseTextClass)
        then
          begin
           (self.controls[i] as IAChartBaseTextClass).SetSelection(false);
          end else
          begin
            if (self.controls[i] is IAChartBaseLinesClass)
              then (self.controls[i] as IAChartBaseLinesClass).SetSelection(false);
          end;
    end;
end;

procedure TIAChartInnerPanel.WMSIZE(var Message: TMessage);
begin
  inherited;
  if assigned(Parent) and (parent.HandleAllocated) then

  while not postmessage(parent.handle,CM_RESIZEINNER,0,0) do begin application.ProcessMessages end;
end;


procedure TIAChartInnerPanel.CMUSERMURESIZED(var Message: TMessage);
begin
  if assigned(parent) and parent.HandleAllocated and (TGraphicControl(Message.WParam) is IAChartBaseTextClass) and
    (Message.LParam<>0) then
    postmessage(parent.handle,CM_RESIZEINNER,0,0);
end;

procedure TIAChartInnerPanel.CMBASELINESMOVED(var Message: TMessage);
begin
  if assigned(Parent) and (parent.HandleAllocated) then postmessage(parent.handle,CM_BASELINESMOVED,Message.WParam,0);
end;

procedure TIAChartInnerPanel.CMBASELINESSIZED(var Message: TMessage);
begin
  if assigned(Parent) and (parent.HandleAllocated) then postmessage(parent.handle,CM_BASELINESSIZED,Message.WParam,0);
end;

procedure TIAChartInnerPanel.CMAXISRECALIBRATED(var Message: TMessage);
var i : integer;
    Amain : IAChartBaseLinesClass;
begin
  AMain:=nil;
  for i:=0 to controlcount-1 do
    begin
      if (controls[i] is IAChartBaseLinesClass) then AMain:=(controls[i] as IAChartBaseLinesClass);
    end;

  if assigned(Parent) and (parent.HandleAllocated) then
   postmessage(parent.handle,CM_AXISRECALIBRATED,Message.WParam,cardinal(AMain));
end;



procedure TIAChartInnerPanel.CMUSERWANTSRESIZE(var Message: TMessage);
begin
  if assigned(Parent) and (parent.HandleAllocated) then
   postmessage(parent.handle,CM_USERWANTSRESIZE,Message.WParam,0);
end;

procedure TIAChartInnerPanel.CMUSERCHANGELINESREPRESENTATION(
  var Message: TMessage);
begin
    if assigned(Parent) and (parent.HandleAllocated) then
   postmessage(parent.handle,CM_USERCHANGELINESREPRESENTATION,0,0);
end;

procedure TIAChartInnerPanel.CMUSERDBLCLICK(var Message: TMessage);
begin
    if assigned(Parent) and (parent.HandleAllocated) then
   postmessage(parent.handle,CM_USERDBLCLICK,Message.WParam,0);
end;

procedure TIAChartInnerPanel.CMAXISDBLCLICKED(var Message: TMessage);
begin
      if assigned(Parent) and (parent.HandleAllocated) then
   postmessage(parent.handle,CM_AXISDBLCLICKED,Message.WParam,0);
end;

procedure TIAChartInnerPanel.Assign(Source: TPersistent);

begin
  if Source is TIAChartInnerPanel then
    begin

    end else
    begin
      inherited Assign(Source);
    end;
end;

end.
